.\" -*- coding: us-ascii -*-
.TH xphelloworld __appmansuffix__ "8 October 2004"  
.SH NAME
xphelloworld \- sends a test page to an Xprint printer
.SH SYNOPSIS
.ad l
\fBxphelloworld\fR \kx
.if (\nxu > (\n(.lu / 2)) .nr x (\n(.lu / 5)
'in \n(.iu+\nxu
[\fB\-printer \fBprinternname\fR\fR] [\fB\-printargs
\fBarg\fR= \fBvalue\fR [,...]\fR] [\fB\-v\fR] [\fB\-text \fBtext\fR\fR] [\fB\-h\fR]
'in \n(.iu-\nxu
.ad b
.SH DESCRIPTION
xphelloworld is a utility for Xprint, the
printing system for the X Window system. It sends a test page to
the specified printer (or the default printer, if none is specified).
.SH OPTIONS
.TP 
\fB\-printer \fIprinternname\fB\fR 
printer to use
.TP 
\fB\-printargs \fIarg\fB=\fIvalue\fB [,...]\fR 
Args:
.RS 
.TP 
\fBtofile=\fIfilename\fB\fR
.TP 
\fBpapersize=\fIpaper name\fB\fR
.TP 
\fBorientation=\fIorientation\fB\fR
.TP 
\fBresolution=\fIDPI\fB\fR
.TP 
\fBplex=\fIplex\fB\fR
.TP 
\fBtitle=\fIstring\fB\fR
.RE

.TP 
\fB\-text \fItext\fB\fR 
Sample text to print. Default is "hello world from X11 print system".
.TP 
\fB\-v\fR 
verbose output
.TP 
\fB\-h\fR 
print usage
.SH ENVIRONMENT
.TP 
\fBXPSERVERLIST\fR 
\fB${XPSERVERLIST}\fR must be set,
identifying the available Xprint servers.
See \fBXprint\fR(__miscmansuffix__)
for more details.
.SH "KNOWN BUGS"

The \fB\-text\fR option assumes that the text is in ISO8859-1 encoding
(the \fB${LANG}\fR environment variable is not honored in this case).

A full list of bugs can be obtained from the Xprint.org bug database (http://xprint.mozdev.org/xprint_bugs.html).
.SH "SEE ALSO"
\fBXprint\fR(__miscmansuffix__), \fBX11\fR(__miscmansuffix__), \fBxplsprinters\fR(__appmansuffix__), \fBxpxmhelloworld\fR(__appmansuffix__), \fBxpawhelloworld\fR(__appmansuffix__), \fBxpxthelloworld\fR(__appmansuffix__), \fBxpsimplehelloworld\fR(__appmansuffix__), \fBXserver\fR(__appmansuffix__), \fBXprt\fR(__appmansuffix__), \fBlibXp\fR(__libmansuffix__), \fBlibXprintUtils\fR(__libmansuffix__), \fBlibXprintAppUtils\fR(__libmansuffix__), \fBXmPrintShell\fR(__libmansuffix__), \fBXawPrintShell\fR(__libmansuffix__), Xprint FAQ (http://xprint.mozdev.org/docs/Xprint_FAQ.html), Xprint main site (http://xprint.mozdev.org/)
