.\" -*- coding: us-ascii -*-
.TH xplsprinters __appmansuffix__ "8 October 2004"  
.SH NAME
xplsprinters \- shows a list of Xprint printers and it's attributes
.SH SYNOPSIS
.ad l
\fBxplsprinters\fR \kx
.if (\nxu > (\n(.lu / 2)) .nr x (\n(.lu / 5)
'in \n(.iu+\nxu
[\fB\-printer \fBprintername\fR\fR] [\fB\-d\fR] [\fB\-l\fR] [\fB\-dump\fR] [\fB\-h\fR]
'in \n(.iu-\nxu
.ad b
.SH DESCRIPTION
xplsprinters is a utility for Xprint, the
printing system for the X Window system. It can deliver both a list
of printers and attributes supported for a specific list of
printers.
.SH OPTIONS
.TP 
\fB\-printer \fIprintername\fB\fR 
printer to use
.TP 
\fB\-dump\fR 
dump all available printer attributes
.TP 
\fB\-h | \-?\fR 
print usage
.TP 
\fB\-d\fR 
print description for each printer
.TP 
\fB\-l\fR 
list detailed printer attribute information
.SH ENVIRONMENT
.TP 
\fBXPSERVERLIST\fR 
\fB${XPSERVERLIST}\fR must be set,
identifying the available Xprint servers.
See \fBXprint\fR(__miscmansuffix__)
for more details.
.SH EXAMPLES
\fBList all available "X Print Specifiers" (printer names)\fR
.PP
.nf
% \fBxplsprinters\fR
.fi
.PP
would print:

.nf
printer: hplaserjet001@puck:33
printer: hpcolor4550_004@puck:33
printer: laser19@meridian:19
printer: xp_ps_spooldir_tmp_Xprintjobs@meridian:19
printer: xp_pdf_spooldir_tmp_Xprintjobs@meridian:19
.fi

.PP
\fBGet information about the supported attributes of printer "ps002":\fR
.PP
.nf
% \fBxplsprinters \-printer ps002 \-l\fR
.fi
.PP
would print:

.nf

printer: ps002@castor:18
        description=
        model\-identifier=HPDJ1600C
        default\-medium=iso\-a4
        default\-input\-tray=
        medium\-source\-sizes\-supported=iso\-a4 false 6.35 203.65 6.35 290.65
        medium\-source\-sizes\-supported=na\-letter false 6.35 209.55 6.35 273.05
        default\-printer\-resolution=300
        resolution=300
        default_orientation=
        orientation=portrait
        orientation=landscape
        default_plex=
        plex=simplex
.fi

.SH NOTES
The list of builtin fonts supported by a printer can be obtained
using the xlsfonts command.
.SH "SEE ALSO"
\fBXprint\fR(__miscmansuffix__), \fBX11\fR(__miscmansuffix__), \fBxprehashprinterlist\fR(__appmansuffix__), \fBxphelloworld\fR(__appmansuffix__), \fBxpxmhelloworld\fR(__appmansuffix__), \fBxpawhelloworld\fR(__appmansuffix__), \fBxpxthelloworld\fR(__appmansuffix__), \fBxpsimplehelloworld\fR(__appmansuffix__), \fBxlsfonts\fR(__appmansuffix__), \fBXserver\fR(__appmansuffix__), \fBXprt\fR(__appmansuffix__), \fBlibXp\fR(__libmansuffix__), \fBlibXprintUtils\fR(__libmansuffix__), \fBlibXprintAppUtils\fR(__libmansuffix__), \fBXmPrintShell\fR(__libmansuffix__), \fBXawPrintShell\fR(__libmansuffix__), Xprint FAQ (http://xprint.mozdev.org/docs/Xprint_FAQ.html), Xprint main site (http://xprint.mozdev.org/)
