.\" -*- coding: us-ascii -*-
.TH xprehashprinterlist __appmansuffix__ "8 October 2004"  
.SH NAME
xprehashprinterlist \- Recomputes the list of available printers.
.SH SYNOPSIS
.ad l
\fBxprehashprinterlist\fR \kx
.if (\nxu > (\n(.lu / 2)) .nr x (\n(.lu / 5)
'in \n(.iu+\nxu
[\fB\-v\fR] [\fB\-h\fR]
'in \n(.iu-\nxu
.ad b
.SH DESCRIPTION
xprehashprinterlist causes all Xprint servers
to recompute (update) their lists of available printers, and update the
attributes for the printers. The intended usage of this tool is that
a system administrator can run it after changing the printer topology.
.SH OPTIONS
.TP 
\fB\-v\fR 
generate verbose output
.TP 
\fB\-h | \-?\fR 
print usage
.SH ENVIRONMENT
.TP 
\fBXPSERVERLIST\fR 
\fB${XPSERVERLIST}\fR must be set,
identifying the available Xprint servers.
See \fBXprint\fR(__miscmansuffix__)
for more details.
.SH EXAMPLES
\fBUpdate the list of available printers\fR
.PP
.nf
% \fBxprehashprinterlist \-v\fR
.fi
.PP
would print:

.nf
Rehashing printer list on server 'meridian:34'
.fi

.SH NOTES
xprehashprinterlist rehashes all printer lists of all print servers.
Alternatively xset rehashprinterlist may be used to rehash only the
list of printers in one print server.
.SH "SEE ALSO"
\fBXprint\fR(__miscmansuffix__), \fBX11\fR(__miscmansuffix__), \fBxset\fR(__appmansuffix__), \fBxplsprinters\fR(__appmansuffix__), \fBxphelloworld\fR(__appmansuffix__), \fBxpxmhelloworld\fR(__appmansuffix__), \fBxpawhelloworld\fR(__appmansuffix__), \fBxpxthelloworld\fR(__appmansuffix__), \fBxpsimplehelloworld\fR(__appmansuffix__), \fBXserver\fR(__appmansuffix__), \fBXprt\fR(__appmansuffix__), \fBlibXp\fR(__libmansuffix__), \fBlibXprintUtils\fR(__libmansuffix__), \fBlibXprintAppUtils\fR(__libmansuffix__), \fBXmPrintShell\fR(__libmansuffix__), \fBXawPrintShell\fR(__libmansuffix__), Xprint FAQ (http://xprint.mozdev.org/docs/Xprint_FAQ.html), Xprint main site (http://xprint.mozdev.org/)
