.\" $XTermId: xterm.man,v 1.288 2004/12/01 01:27:47 tom Exp $
.\" $Xorg: xterm.man,v 1.4 2001/02/09 02:06:03 xorgcvs Exp $
.\"
.\"
.\" Copyright 1996-2003,2004 by Thomas E. Dickey
.\"
.\"                         All Rights Reserved
.\"
.\" Permission is hereby granted, free of charge, to any person obtaining a
.\" copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\"
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY
.\" CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
.\" TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
.\" SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
.\"
.\" Except as contained in this notice, the name(s) of the above copyright
.\" holders shall not be used in advertising or otherwise to promote the
.\" sale, use or other dealings in this Software without prior written
.\" authorization.
.\"
.\"
.\" Copyright 1989  The Open Group
.\"
.\" Permission to use, copy, modify, distribute, and sell this software and its
.\" documentation for any purpose is hereby granted without fee, provided that
.\" the above copyright notice appear in all copies and that both that
.\" copyright notice and this permission notice appear in supporting
.\" documentation.
.\"
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\"
.\" Except as contained in this notice, the name of The Open Group shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from The Open Group.
.\"
.\" $XFree86: xc/programs/xterm/xterm.man,v 3.110 2004/12/01 01:27:47 dickey Exp $
.\"
.\" updated by Thomas E. Dickey for XFree86, July 1996 - July 2004.
.TH XTERM 1 __vendorversion__
.SH NAME
xterm \- terminal emulator for X
.SH SYNOPSIS
.B xterm
[-\fItoolkitoption\fP ...] [-option ...]
.SH DESCRIPTION
The \fIxterm\fP program is a terminal emulator for the X Window System.
It provides DEC VT102/VT220 (VTxxx) and Tektronix 4014
compatible terminals for programs that cannot
use the window system directly.
If the underlying operating system supports
terminal resizing capabilities (for example, the SIGWINCH signal in systems
derived from 4.3bsd), \fIxterm\fP will use the facilities to notify programs
running in the window whenever it is resized.
.
.PP
The VTxxx and Tektronix 4014 terminals each have their own window so that you
can edit text in one and look at graphics in the other at the same time.
To maintain the correct aspect ratio (height/width), Tektronix graphics will
be restricted to the largest box with a 4014's aspect ratio that will fit in
the window.
This box is located in the upper left area of the window.
.
.PP
Although both windows may be displayed at the same time, one of them is
considered the ``active'' window for receiving keyboard input and terminal
output.
This is the window that contains the text cursor.
The active window can be chosen through escape sequences,
the ``VT Options'' menu in the VTxxx window, and the ``Tek Options''
menu in the 4014 window.
.
.SH EMULATIONS
The VT102 emulation is fairly complete, but does not support
autorepeat.
Double-size characters are displayed properly if your font server supports
scalable fonts.
The VT220 emulation does not support soft fonts, it is otherwise complete.
.IR Termcap (5)
entries that work with
.I xterm
include
an optional platform-specific entry,
``xterm,'' ``vt102,'' ``vt100'' and ``ansi,'' and ``dumb.''
.I xterm
automatically searches the termcap file in this order for these entries and then
sets the ``TERM'' and the ``TERMCAP'' environment variables.
You may also use ``vt220,''  but must set the terminal emulation level
with the \fBdecTerminalID\fP resource.
(The ``TERMCAP'' environment variable is not set if \fIxterm\fP is linked
against a terminfo library, since the requisite information is not provided
by the termcap emulation of terminfo libraries).
.
.PP
Many of the special
.I xterm
features may be modified under program control
through a set of escape sequences different from the standard VT102 escape
sequences.
(See the
.I "Xterm Control Sequences"
document.)
.
.PP
The Tektronix 4014 emulation is also fairly good.
It supports 12-bit graphics addressing, scaled to the window size.
Four different font sizes and five different lines types are supported.
There is no write-through or defocused mode support.
The Tektronix text and graphics commands are recorded internally by
.I xterm
and may be written to a file by sending the COPY escape sequence (or through
the
.B Tektronix
menu; see below).
The name of the file will be
``\fBCOPY\fIyyyy\fB-\fIMM\fB-\fIdd\fB.\fIhh\fB:\fImm\fB:\fIss\fR'', where
.IR yyyy ,
.IR MM ,
.IR dd ,
.IR hh ,
.I mm
and
.I ss
are the year, month, day, hour, minute and second when the COPY was performed
(the file is created in the directory
.I xterm
is started in, or the home directory for a login
.IR xterm ).
.
.PP
Not all of the features described in this manual are necessarily available in
this version of \fIxterm\fP.
Some (e.g., the non-VT220 extensions) are available
only if they were compiled in, though the most commonly-used are in the
default configuration.
.
.SH "OTHER FEATURES"
.I Xterm
automatically highlights the text cursor when the
pointer enters the window (selected) and unhighlights it when the pointer
leaves the window (unselected).
If the window is the focus window, then the text cursor is
highlighted no matter where the pointer is.
.
.PP
In VT102 mode, there are escape sequences to activate and deactivate
an alternate screen buffer, which is the same size as the display area
of the window.
When activated, the current screen is saved and replaced with the alternate
screen.
Saving of lines scrolled off the top of the window is disabled until the
normal screen is restored.
The
.IR termcap (5)
entry for
.I xterm
allows the visual editor
.IR vi (1)
to switch to the alternate screen for editing and to restore the screen
on exit.
A popup menu entry makes it simple to switch between the normal and
alternate screens for cut and paste.
.
.PP
In either VT102 or Tektronix mode, there are escape sequences to change the
name of the windows.
Additionally, in VT102 mode,
\fIxterm\fP implements the window-manipulation control
sequences from \fIdtterm\fP, such as resizing the window, setting its location
on the screen.
.
.PP
.I Xterm
allows character-based applications to receive mouse events (currently
button-press and release events, and button-motion events)
as keyboard control sequences.
See \fIXterm Control Sequences\fP for details.
.
.
.SH OPTIONS
The \fIxterm\fP terminal emulator
accepts all of the standard X Toolkit command line options as well as
the following.
If the option begins with a
.RB ` + '
instead of a
.RB ` - ',
the option is restored to its default value.
The \fB-version\fP and \fB-help\fP options are interpreted even if \fIxterm\fP cannot
open the display, and are useful for testing and configuration scripts:
.TP 8
.B -version
This causes \fIxterm\fP to print a version number to the standard output.
.TP 8
.B -help
This causes \fIxterm\fP to print out a verbose message describing its options.
The message is written to the standard error.
.
.PP
The other options are used to control the appearance and behavior.
Not all options are necessarily configured into your copy of \fIxterm\fP.
.TP 8
.B -132
Normally, the VT102 DECCOLM escape sequence that switches between 80 and
132 column mode is ignored.
This option causes the DECCOLM escape sequence to be recognized, and the
.I xterm
window will resize appropriately.
.TP 8
.B -ah
This option indicates that
.I xterm
should always highlight the text cursor.
By default,
.I xterm
will display a hollow text cursor whenever the focus is lost or the
pointer leaves the window.
.TP 8
.B +ah
This option indicates that
.I xterm
should do text cursor highlighting based on focus.
.TP 8
.B -ai
This option disables active icon support if that feature was compiled
into \fIxterm\fP.
This is equivalent to setting the \fIvt100\fP resource
\fBactiveIcon\fP to FALSE.
.TP 8
.B +ai
This option enables active icon support if that feature was compiled
into \fIxterm\fP.
This is equivalent to setting the \fIvt100\fP resource
\fBactiveIcon\fP to TRUE.
.TP 8
.B -aw
This option indicates that auto-wraparound should be allowed.
This
allows the cursor to automatically wrap to the beginning of the next
line when when it is at the rightmost position of a line and text is
output.
.TP 8
.B +aw
This option indicates that auto-wraparound should not be allowed.
.TP 8
.BI -b " number"
This option specifies the size of the inner border (the distance between
the outer edge of the characters and the window border) in pixels.
The
default is 2.
.TP 8
.B +bc
turn off text cursor blinking.
This overrides the \fBcursorBlink\fR resource.
.TP 8
.B -bc
turn on text cursor blinking.
This overrides the \fBcursorBlink\fR resource.
.TP 8
.BI -bcf " milliseconds"
time text cursor is off when blinking
.TP 8
.BI -bcn " milliseconds"
time text cursor is on when blinking
.TP 8
.B "-bdc"
Set the \fIvt100\fP resource \fBcolorBDMode\fR to FALSE,
disabling the display of characters with bold attribute as color
.TP 8
.B "+bdc"
Set the \fIvt100\fP resource \fBcolorBDMode\fR to TRUE,
enabling the display of characters with bold attribute as color
rather than bold
.TP 8
.B "-cb"
Set the \fIvt100\fP resource \fBcutToBeginningOfLine\fP to FALSE.
.TP 8
.B "+cb"
Set the \fIvt100\fP resource \fBcutToBeginningOfLine\fP to TRUE.
.TP 8
.B "-cc \fIcharacterclassrange\fP:\fIvalue\fP[,...]"
This sets classes indicated by the given ranges for using in selecting by
words.
See the section specifying character classes.
.TP 8
.B "-cjk_width"
Set the \fBcjkWidth\fP resource to ``true''.
When turned on, characters with East Asian Ambiguous (A) category in UTR 11
have a column width of 2.
Othrwise, they have a column width of 1.
This may be useful for some legacy CJK text
terminal-based programs assuming box drawings and others to have a column
width of 2.
It also has to be turned on when you specify a truetype
CJK double-width (bi-width/monospace) font either with \fB-fa\fP at
the command line or \fBfaceName\fP resource.
The default is ``false''
.TP 8
.B "+cjk_width"
Reset the \fBcjkWidth\fP resource.
.TP 8
.BI -class " string"
This option allows you to override \fIxterm\fP's resource class.
Normally it is ``XTerm'', but
can be set to another class such as ``UXTerm'' to override selected resources.
.TP 8
.B "-cm"
This option disables recognition of ANSI color-change escape sequences.
.TP 8
.B "+cm"
This option enables recognition of ANSI color-change escape sequences.
This is the same as the \fIvt100\fP resource \fBcolorMode\fP.
.TP 8
.B "-cn"
This option indicates that newlines should not be cut in line-mode
selections.
.TP 8
.B +cn
This option indicates that newlines should be cut in line-mode selections.
.TP 8
.BI -cr " color"
This option specifies the color to use for text cursor.
The default is to
use the same foreground color that is used for text.
.TP 8
.B -cu
This option indicates that \fIxterm\fP should work around a bug in the
.IR more (1)
program that causes it
to incorrectly display lines that are exactly the width of the window and
are followed by a line beginning with a tab
(the leading tabs are not displayed).
This option is so named because it was originally thought to be a bug
in the
.IR curses (3x)
cursor motion package.
.TP 8
.B +cu
This option indicates that \fIxterm\fP should not work around the
.IR more (1)
bug mentioned above.
.TP 8
.B "-dc"
This option disables the escape sequence to change dynamic colors:
the vt100 foreground and background colors,
its text cursor color,
the pointer cursor foreground and background colors,
the Tektronix emulator foreground and background colors,
its text cursor color
and highlight color.
.TP 8
.B "+dc"
This option enables the escape sequence to change dynamic colors.
.TP 8
.BI -e " program \fP[ \fIarguments \fP.\|.\|. ]\fI"
This option specifies the program (and its command line arguments) to be
run in the \fIxterm\fP window.
It also sets the window title and icon
name to be the basename of the program being executed if neither \fI-T\fP
nor \fI-n\fP are given on the command line.
\fBThis must be the last option on the command line.\fP
.TP 8
.BI -en " encoding"
This option determines the encoding on which \fIxterm\fP runs.
It corresponds to the \fBlocale\fR resource.
Encodings other than UTF-8 are supported by using \fIluit\fR.
The \fB-lc\fR option should be used instead of \fB-en\fR for
systems with locale support.
.TP 8
.BI -fb " font"
This option specifies a font to be used when displaying bold text.
This font must be the same height and width as the normal font.
If only one of the normal or bold fonts is specified, it will be used as the
normal font and the bold font will be produced by overstriking this font.
The default is to do overstriking of the normal font.
See also the discussion of \fBboldFont\fP and \fBboldMode\fP resources.
.TP 8
.BI -fa " pattern"
This option sets the pattern for fonts selected from the FreeType
library if support for that library was compiled into \fIxterm\fP.
This corresponds to the \fBfaceName\fP resource.
When a CJK
double-width font is specified, you also need to turn
on the \fBcjkWidth\fP resource.
.TP 8
.BI -fbb
This option indicates that \fIxterm\fP should compare normal and bold fonts bounding
boxes to ensure they are compatible.
.TP 8
.BI +fbb
This option indicates that \fIxterm\fP should not compare normal and bold fonts bounding
boxes to ensure they are compatible.
.TP 8
.BI -fbx
This option indicates that \fIxterm\fP should not assume that the
normal and bold fonts have VT100 line-drawing characters.
If any are missing, \fIxterm\fP will draw the characters directly.
.TP 8
.BI +fbx
This option indicates that \fIxterm\fP should assume that the
normal and bold fonts have VT100 line-drawing characters.
.TP 8
.BI -fd " pattern"
This option sets the pattern for double-width fonts selected from the FreeType
library if support for that library was compiled into \fIxterm\fP.
This corresponds to the \fBfaceNameDoublesize\fP resource.
.TP 8
.BI -fi " font"
This option sets the font for active icons if that feature was compiled
into \fIxterm\fP.
See also the discussion of the \fBiconFont\fP resource.
.TP 8
.BI -fs " size"
This option sets the pointsize for fonts selected from the FreeType
library if support for that library was compiled into \fIxterm\fP.
This corresponds to the \fBfaceSize\fP resource.
.TP 8
.B -fw \fIfont\fP
This option specifies the font to be used for displaying wide text.
By default,
it will attempt to use a font twice as wide as the font that will be used to
draw normal text.
If no doublewidth font is found, it will improvise, by stretching
the normal font.
This corresponds to the \fBwideFont\fP resource.
.TP 8
.B -fwb \fIfont\fP
This option specifies the font to be used for displaying bold wide text.
By default,
it will attempt to use a font twice as wide as the font that will be used to
draw bold text.
If no doublewidth font is found, it will improvise, by stretching
the bold font.
This corresponds to the \fBwideBoldFont\fP resource.
.TP 8
.B -fx \fIfont\fP
This option specifies the font to be used for displaying the preedit string
in the "OverTheSpot" input method.
See also the discussion of the \fBximFont\fP resource.
.TP 8
.BI -hc " color"
This option specifies the color to use for the background of
selected or otherwise highlighted text.
If not specified,
reverse video is used.
.TP 8
.BI -hf
This option indicates that HP Function Key escape codes should be generated
for function keys.
.TP 8
.BI +hf
This option indicates that HP Function Key escape codes should not be generated
for function keys.
.TP 8
.BI -hold
Turn on the \fBhold\fP resource, i.e.,
\fIxterm\fP will not immediately destroy its window when the shell command completes.
It will wait until you use the window manager to destroy/kill the window, or
if you use the menu entries that send a signal, e.g., HUP or KILL.
.TP 8
.BI +hold
Turn off the \fBhold\fP resource, i.e.,
\fIxterm\fP will immediately destroy its window when the shell command completes.
.TP 8
.B -ie
Turn on the \fBptyInitialErase\fP resource, i.e.,
use the pseudo-terminal's sense of the stty erase value.
.TP 8
.B +ie
Turn off the \fBptyInitialErase\fP resource, i.e.,
set the stty erase value using the \fBkb\fP string from the termcap entry as
a reference, if available.
.TP 8
.B -im
Turn on the \fBuseInsertMode\fP resource.
.TP 8
.B +im
Turn off the \fBuseInsertMode\fP resource.
.TP 8
.BI -into " windowId"
Given an X window identifier (a decimal integer),
\fIxterm\fP will reparent its top-level shell widget to that window.
This is used to embed \fIxterm\fP within other applications.
.TP 8
.B -j
This option indicates that \fIxterm\fP should do jump scrolling.
Normally,
text is scrolled one line at a time; this option allows \fIxterm\fP to move
multiple lines at a time so that it does not fall as far behind.
Its use is
strongly recommended since it makes \fIxterm\fP much faster when scanning
through large amounts of text.
The VT100 escape sequences for enabling and
disabling smooth scroll as well as the ``VT Options''
menu can be used to turn this
feature on or off.
.TP 8
.B +j
This option indicates that \fIxterm\fP should not do jump scrolling.
.TP 8
.B -k8
This option sets the \fBallowC1Printable\fP resource.
When \fBallowC1Printable\fP is set, \fIxterm\fP overrides the mapping
of C1 control characters (code 128-159) to treat them as printable.
.TP 8
.B +k8
This option resets the \fBallowC1Printable\fP resource.
.TP 8
.B -l
Turn logging on.
Normally logging is not supported, due to security concerns.
Some versions of \fIxterm\fP may have logging enabled.
The logfile is written to the directory from which \fIxterm\fP is
invoked.
The filename is generated, of the form
.sp
	XtermLog.\fIXXXXXX\fR
.sp
or
.sp
	Xterm.log.\fIhostname.yyyy.mm.dd.hh.mm.ss.XXXXXX\fR
.sp
depending on how \fIxterm\fP was built.
.TP 8
.B +l
Turn logging off.
.TP 8
.B -lc
Turn on support of various encodings according to the users'
locale setting, i.e., LC_ALL, LC_CTYPE, or LANG environment variables.
This is achieved by turning on UTF-8 mode and by invoking \fIluit\fR for
conversion between locale encodings and UTF-8.
(\fIluit\fR is not invoked in UTF-8 locales.)
This corresponds to the \fBlocale\fR resource.
.IP
The actual list of encodings which are supported is determined by \fIluit\fR.
Consult the \fIluit\fR manual page for further details.
See also the discussion of the \fB-u8\fP option which supports UTF-8 locales.
.TP 8
.B +lc
Turn off support of automatic selection of locale encodings.
Conventional 8bit mode or, in UTF-8 locales or with \fB-u8\fP option,
UTF-8 mode will be used.
.TP 8
.BI -lcc " path"
File name for the encoding converter from/to locale encodings
and UTF-8 which is used with \fB-lc\fP option or \fBlocale\fR resource.
This corresponds to the \fBlocaleFilter\fR resource.
.TP 8
.B -leftbar
Force scrollbar to the left side of VT100 screen.
This is the default, unless you have set the rightScrollBar resource.
.TP 8
.BI -lf " filename"
Specify the log-filename.
See the \fB-l\fP option.
.TP 8
.B -ls
This option indicates that the shell that is started in the \fIxterm\fP window
will be a login shell (i.e., the first character of argv[0] will be a dash,
indicating to the shell that it should read the user's .login or .profile).
.IP
The \fB-ls\fP flag and the \fBloginShell\fP resource
are ignored if \fB-e\fP is also given,
because \fIxterm\fP does not know how to make the shell
start the given command after whatever it does when it is a login
shell - the user's shell of choice need not be a Bourne shell after all.
Also, \fIxterm\ -e\fP is supposed to provide a consistent
functionality for other applications that need to start text-mode
programs in a window, and if \fBloginShell\fP were not ignored, the
result of ~/.profile might interfere with that.
.IP
If you do want the effect of \fB-ls\fP and \fB-a\fP simultaneously, you
may get away with something like
.RS 15
xterm -e /bin/bash -l -c "my command here"
.RE
.IP
Finally, \fB-ls\fP is not completely ignored,
because \fIxterm\ -ls\ -e\fP does write a \fI/etc/wtmp\fP entry
(if configured to do so),
whereas \fIxterm\ -e\fP does not.
.TP 8
.B +ls
This option indicates that the shell that is started should not be a login
shell (i.e., it will be a normal ``subshell'').
.TP 8
.B -mb
This option indicates that \fIxterm\fP should ring a margin bell when
the user types near the right end of a line.
This option can be turned on
and off from the ``VT Options'' menu.
.TP 8
.B +mb
This option indicates that margin bell should not be rung.
.TP 8
.BI -mc " milliseconds"
This option specifies the maximum time between multi-click selections.
.TP 8
.B -mesg
Turn off the \fBmessages\fP resource, i.e.,
disallow write access to the terminal.
.TP 8
.B +mesg
Turn on the \fBmessages\fP resource, i.e.,
allow write access to the terminal.
.TP 8
.BI -ms " color"
This option specifies the color to be used for the pointer cursor.
The default
is to use the foreground color.
.TP 8
.BI -nb " number"
This option specifies the number of characters from the right end of a line
at which the margin bell, if enabled, will ring.
The default is 10.
.TP 8
.B "-nul"
This option disables the display of underlining.
.TP 8
.B "+nul"
This option enables the display of underlining.
.TP 8
.B -pc
This option enables the PC-style use of bold colors (see boldColors
resource).
.TP 8
.B +pc
This option disables the PC-style use of bold colors.
.TP 8
.B -pob
This option indicates that the window should be raised whenever a
Control-G is received.
.TP 8
.B +pob
This option indicates that the window should not be raised whenever a
Control-G is received.
.TP 8
.B -rightbar
Force scrollbar to the right side of VT100 screen.
.TP 8
.B "-rvc"
This option disables the display of characters with reverse attribute as color.
.TP 8
.B "+rvc"
This option enables the display of characters with reverse attribute as color.
.TP 8
.B -rw
This option indicates that reverse-wraparound should be allowed.
This allows
the cursor to back up from the leftmost column of one line to the rightmost
column of the previous line.
This is very useful for editing long shell
command lines and is encouraged.
This option can be turned on and off from
the ``VT Options'' menu.
.TP 8
.B +rw
This option indicates that reverse-wraparound should not be allowed.
.TP 8
.B -s
This option indicates that \fIxterm\fP may scroll asynchronously, meaning that
the screen does not have to be kept completely up to date while scrolling.
This allows \fIxterm\fP to run faster when network latencies are very high
and is typically useful when running across a very large internet or many
gateways.
.TP 8
.B +s
This option indicates that \fIxterm\fP should scroll synchronously.
.TP 8
.B -samename
Does not send title and icon name change requests when the request
would have no effect: the name is not changed.
This has the advantage
of preventing flicker and the disadvantage of requiring an extra
round trip to the server to find out the previous value.
In practice
this should never be a problem.
.TP 8
.B +samename
Always send title and icon name change requests.
.TP 8
.B -sb
This option indicates that some number of lines that are scrolled off the top
of the window should be saved and that a scrollbar should be displayed so that
those lines can be viewed.
This option may be turned on and off from the
``VT Options'' menu.
.TP 8
.B +sb
This option indicates that a scrollbar should not be displayed.
.TP 8
.B -sf
This option indicates that Sun Function Key escape codes should be generated
for function keys.
.TP 8
.B +sf
This option indicates that the standard escape codes should be generated for
function keys.
.TP 8
.B -si
This option indicates that output to a window should not automatically
reposition the screen to the bottom of the scrolling region.
This option can be turned on and off from the ``VT Options'' menu.
.TP 8
.B +si
This option indicates that output to a window should cause it to
scroll to the bottom.
.TP 8
.B -sk
This option indicates that pressing a key while
using the scrollbar to review previous lines of text should
cause the window to be repositioned automatically in the normal position at the
bottom of the scroll region.
.TP 8
.B +sk
This option indicates that pressing a key while using the scrollbar
should not cause the window to be repositioned.
.TP 8
.BI -sl " number"
This option specifies the number of lines to save that have been scrolled
off the top of the screen.
This corresponds to the \fBsaveLines\fP resource.
The default is 64.
.TP 8
.B -sm
This option, corresponding to the \fBsessionMgt\fR resource,
indicates that \fIxterm\fR should
set up session manager callbacks.
.TP 8
.B +sm
This option indicates that \fIxterm\fR should
not set up session manager callbacks.
.TP 8
.B -sp
This option indicates that Sun/PC keyboard should be assumed,
providing mapping for keypad `+' to `,', and
CTRL-F1 to F13, CTRL-F2 to F14, etc.
.TP 8
.B +sp
This option indicates that the standard escape codes should be generated for
keypad and function keys.
.TP 8
.B -t
This option indicates that \fIxterm\fP should start in Tektronix mode, rather
than in VT102 mode.
Switching between the two windows is done using the
``Options'' menus.
.IR Termcap (5)
entries that work with
.I xterm
``tek4014,'' ``tek4015,'' ``tek4012'', ``tek4013'' and ``tek4010,'' and ``dumb.''
.I xterm
automatically searches the termcap file in this order for these entries and then
sets the ``TERM'' and the ``TERMCAP'' environment variables.
.TP 8
.B +t
This option indicates that \fIxterm\fP should start in VT102 mode.
.TP 8
.BI -ti " term_id"
Specify the name used by \fIxterm\fP to select the
correct response to terminal ID queries.
It also specifies the emulation level,
used to determine the type of response to a DA control sequence.
Valid values include vt52, vt100, vt101, vt102, and vt220 (the "vt" is optional).
The default is vt100.
The term_id argument specifies the terminal ID to use.
(This is the same as the \fBdecTerminalID\fP resource).
.TP 8
.BI -tm " string"
This option specifies a series of terminal setting keywords followed by the
characters that should be bound to those functions, similar to the \fIstty\fP
program.
The keywords and their values are described in detail in the \fBttyModes\fP
resource.
.TP 8
.BI -tn " name"
This option specifies the name of the terminal type to be set in the TERM
environment variable.
It corresponds to the \fBtermName\fP resource.
This terminal type must exist in the terminal
database
(termcap or terminfo, depending on how \fIxterm\fP is built)
and should have \fIli#\fP and \fIco#\fP entries.
If the terminal type is not found, \fIxterm\fP uses the built-in list
``xterm'', ``vt102'', etc.
.TP 8
.B -u8
This option sets the \fButf8\fP resource.
When \fButf8\fP is set, \fIxterm\fP interprets incoming data as UTF-8.
This sets the \fBwideChars\fP resource as a side-effect,
but the UTF-8 mode set by this option prevents it from being turned off.
If you must turn it on and off, use the \fBwideChars\fP resource.
.IP
This option and the \fButf8\fR resource are overridden by
the \fB-lc\fP and \fB-en\fP options and \fBlocale\fR resource.
That is, if \fIxterm\fP has been compiled to support \fIluit\fR,
and the \fBlocale\fP resource is not ``false''
this option is ignored.
We recommend using
the \fB-lc\fR option or the ``\fBlocale:\ true\fR'' resource
in UTF-8 locales when your operating system supports locale,
or \fB-en\ UTF-8\fP option or the ``\fBlocale:\ UTF-8\fR'' resource
when your operating system does not support locale.
.TP 8
.B +u8
This option resets the \fButf8\fP resource.
.TP 8
.B "-ulc"
This option disables the display of characters with underline attribute as
color rather than with underlining.
.TP 8
.B "+ulc"
This option enables the display of characters with underline attribute as
color rather than with underlining.
.TP 8
.B -ut
This option indicates that \fIxterm\fP should not write a record into the
the system \fIutmp\fP log file.
.TP 8
.B +ut
This option indicates that \fIxterm\fP should write a record into
the system \fIutmp\fP log file.
.TP 8
.B -vb
This option indicates that a visual bell is preferred over an audible one.
Instead of ringing the terminal bell whenever a Control-G is received, the
window will be flashed.
.TP 8
.B +vb
This option indicates that a visual bell should not be used.
.TP 8
.B -wc
This option sets the \fBwideChars\fP resource.
When \fBwideChars\fP is set, \fIxterm\fP maintains internal structures for 16-bit
characters.
If you do not set this resource to ``true'',
\fIxterm\fP will ignore the escape sequence which turns UTF-8 mode on and off.
The default is ``false''.
.TP 8
.B +wc
This option resets the \fBwideChars\fP resource.
.TP 8
.B -wf
This option indicates that \fIxterm\fP should wait for the window to be mapped
the first time before starting the subprocess so that the initial terminal
size settings and environment variables are correct.
It is the application's
responsibility to catch subsequent terminal size changes.
.TP 8
.B +wf
This option indicates that \fIxterm\fP show not wait before starting the
subprocess.
.TP 8
.B -ziconbeep \fIpercent\fP
Same as zIconBeep resource.
If percent is non-zero, xterms that produce output while iconified
will cause an XBell sound at the given volume
and have "***" prepended to their icon titles.
Most window managers will detect this change immediately, showing you
which window has the output.
(A similar feature was in x10 \fIxterm\fP.)
.TP 8
.B -C
This option indicates that this window should receive console output.
This
is not supported on all systems.
To obtain console output, you must be the
owner of the console device, and you must have read and write permission
for it.
If you are running X under \fIxdm\fP on the console screen you may
need to have the session startup and reset programs explicitly change the
ownership of the console device in order to get this option to work.
.TP 8
.B -S\fIccn\fP
This option allows \fIxterm\fP to be used as an input and
output channel for an existing program and is sometimes used in specialized
applications.
The option value specifies the last few letters of the name of a pseudo-terminal
to use in slave mode, plus the number of the inherited file descriptor.
If the option contains a ``/'' character, that delimits the characters
used for the pseudo-terminal name from the file descriptor.
Otherwise, exactly two characters are used from the option for
the pseudo-terminal name, the remainder is the file descriptor.
Examples:
.nf
.RS 15
-S123/45
-Sab34
.RE
.fi
.IP
Note that \fIxterm\fP does not close any file descriptor
which it did not open for its own use.
It is possible (though probably not portable) to have an application
which passes an open file descriptor down to \fIxterm\fP past the
initialization or the \fB-S\fP option to a process running in the \fIxterm\fP.
.PP
The following command line arguments are provided for compatibility with
older versions.
They may not be supported in the next release as the X
Toolkit provides standard options that accomplish the same task.
.TP 8
.B "%\fIgeom\fP"
This option specifies the preferred size and position of the Tektronix window.
It is shorthand for specifying the ``\fI*tekGeometry\fP'' resource.
.TP 8
.B \ #\fIgeom\fP
This option specifies the preferred position of the icon window.
It is shorthand for specifying the ``\fI*iconGeometry\fP'' resource.
.TP 8
.BI -T " string"
This option specifies the title for \fIxterm\fP's windows.
It is equivalent to \fB-title\fP.
.TP 8
.BI -n " string"
This option specifies the icon name for \fIxterm\fP's windows.
It is shorthand for specifying the ``\fI*iconName\fP'' resource.
Note that this is not the same as the toolkit option \fB-name\fP (see below).
The default icon name is the application name.
.TP 8
.B -r
This option indicates that reverse video should be simulated by swapping
the foreground and background colors.
It is equivalent to
\fB-rv\fP.
.TP 8
.BI -w " number"
This option specifies the width in pixels of the border surrounding the window.
It is equivalent to \fB-borderwidth\fP or \fB-bw\fP.
.
.PP
The following standard X Toolkit command line arguments are commonly used
with \fIxterm\fP:
.TP 8
.B -bd \fIcolor\fP
This option specifies the color to use for the border of the window.
The default is ``black.''
.TP 8
.B -bg \fIcolor\fP
This option specifies the color to use for the background of the window.
The default is ``white.''
.TP 8
.B -bw \fInumber\fP
This option specifies the width in pixels of the border surrounding the window.
.TP 8
.B -display \fIdisplay\fP
This option specifies the X server to contact; see \fIX(__miscmansuffix__)\fP.
.TP 8
.B -fg \fIcolor\fP
This option specifies the color to use for displaying text.
The default is
``black.''
.TP 8
.B -fn \fIfont\fP
This option specifies the font to be used for displaying normal text.
The
default is \fIfixed\fP.
.TP 8
.B -font \fIfont\fP
This is the same as \fB-fn\fP.
.TP 8
.B -geometry \fIgeometry\fP
This option specifies the preferred size and position of the VT102 window;
see \fIX(__miscmansuffix__)\fP.
.TP 8
.B -iconic
This option indicates that \fIxterm\fP should ask the window manager to
start it as an icon rather than as the normal window.
.TP 8
.B -name \fIname\fP
This option specifies the application name under which resources are to be
obtained, rather than the default executable file name.
\fIName\fP should not contain ``.'' or ``*'' characters.
.TP 8
.B -rv
This option indicates that reverse video should be simulated by swapping
the foreground and background colors.
.TP 8
.B +rv
Disable the simulation of reverse video by swapping foreground and background
colors.
.TP 8
.B -title \fIstring\fP
This option specifies the window title string, which may be displayed by
window managers if the user so chooses.
The default title is the command
line specified after the \fB-e\fP option, if any, otherwise the application
name.
.TP 8
.B -xrm \fIresourcestring\fP
This option specifies a resource string to be used.
This is especially
useful for setting resources that do not have separate command line options.
.
.
.SH RESOURCES
The program understands all of the core X Toolkit resource names and classes.
Application specific resources (e.g., "\fBXTerm.\fP\fINAME\fP") follow:
.TP 8
.B "backarrowKeyIsErase (\fPclass\fB BackarrowKeyIsErase)"
Tie the VTxxx \fBbackarrowKey\fP and \fBptyInitialErase\fP resources
together by setting the DECBKM state according to whether the initial value of
stty erase is a backspace (8) or delete (127) character.
The default is ``false'', which disables this feature.
.TP 8
.B "hold (\fPclass\fB Hold)"
If true,
\fIxterm\fP will not immediately destroy its window when the shell command completes.
It will wait until you use the window manager to destroy/kill the window, or
if you use the menu entries that send a signal, e.g., HUP or KILL.
You may scroll back, select text, etc., to perform most graphical operations.
Resizing the display will lose data, however, since this involves interaction
with the shell which is no longer running.
.TP 8
.B "hpFunctionKeys (\fPclass\fB HpFunctionKeys)"
Specifies whether or not HP Function Key escape codes should be generated for
function keys instead of standard escape sequences.
.TP 8
.B "iconGeometry (\fPclass\fB IconGeometry)"
Specifies the preferred size and position of the application when iconified.
It is not necessarily obeyed by all window managers.
.TP 8
.B "iconName (\fPclass\fB IconName)"
Specifies the icon name.
The default is the application name.
.TP 8
.B "messages (\fPclass\fB Messages)"
Specifies whether write access to the terminal is allowed initially.
See
.BR mesg (1).
The default is ``true''.
.TP 8
.B "ptyHandshake (\fPclass\fBPtyHandshake)
If ``true'', \fIxterm\fP will perform handshaking during initialization
to ensure that the parent and child processes update the \fButmp\fP
and \fBstty\fP state.
Platforms with newer pseudo-terminal interfaces do not require this feature;
normally it is not configured.
The default is ``true''.
.TP 8
.B "ptyInitialErase (\fPclass\fB PtyInitialErase)"
If ``true'', \fIxterm\fP will use the pseudo-terminal's sense of the stty erase
value.
If ``false'', \fIxterm\fP will set the stty erase value to match its own
configuration, using the \fBkb\fP string from the termcap entry as
a reference, if available.
In either case, the result is applied to the TERMCAP variable
which \fIxterm\fP sets.
The default is ``false''.
.TP 8
.B "sameName (\fPclass\fB SameName)"
If the value of this resource is ``true'', \fIxterm\fP does not send
title and icon name change requests when the request
would have no effect: the name is not changed.
This has the advantage
of preventing flicker and the disadvantage of requiring an extra
round trip to the server to find out the previous value.
In practice
this should never be a problem.
The default is ``true''.
.TP 8
.B "scoFunctionKeys (\fPclass\fB ScoFunctionKeys)"
Specifies whether or not SCP Function Key escape codes should be generated for
function keys instead of standard escape sequences.
.TP 8
.B "sessionMgt (\fPclass\fB SessionMgt)"
If the value of this resource is ``true'',
\fIxterm\fP sets up session manager callbacks
for \fBXtNdieCallback\fR and \fBXtNsaveCallback\fR.
The default is ``true''.
.TP 8
.B "sunFunctionKeys (\fPclass\fB SunFunctionKeys)"
Specifies whether or not Sun Function Key escape codes should be generated for
function keys instead of standard escape sequences.
.TP 8
.B "sunKeyboard (\fPclass\fB SunKeyboard)"
Specifies whether or not Sun/PC keyboard layout should be assumed rather
than DEC VT220.
This causes the keypad `+' to be mapped to `,'.
and
CTRL F1-F12 to F11-F20, depending on the setting of the \fBctrlFKeys\fP
resource.
so \fIxterm\fP emulates a DEC VT220 more accurately.
Otherwise (the default, with \fBsunKeyboard\fP set to ``false''),
\fIxterm\fP uses PC-style bindings for the function keys and keypad.
.IP
PC-style bindings
use the Shift, Alt, Control and Meta keys as modifiers for function-keys
and keypad
(see the document \fIXterm Control Sequences\fP for details).
The PC-style bindings are analogous to PCTerm, but not the same thing.
Normally these bindings do not conflict with the use of the Meta key
as described for the \fBeightBitInput\fP resource.
If they do, note that the PC-style bindings are evaluated first.
.TP 8
.B "termName (\fPclass\fB TermName)"
Specifies the terminal type name to be set in the TERM environment variable.
.TP 8
.B "title (\fPclass\fB Title)"
Specifies a string that may be used by the window manager when displaying
this application.
.TP 8
.B "ttyModes (\fPclass\fB TtyModes)"
Specifies a string containing terminal setting keywords and the characters
to which they may be bound.
Allowable keywords include:
brk,
dsusp,
eof,
eol,
eol2,
erase,
erase2,
flush,
intr,
kill,
lnext,
quit,
rprnt,
start,
status,
stop,
susp,
swtch and
weras.
Control characters may be specified as ^char (e.g., ^c or ^u)
and \fB^?\fP may be used to indicate delete (127).
Use \fB^-\fP to denote \fIundef\fP.
Use \fB\\034\fP to represent \fB^\\\fP, since a literal backslash in
an X resource escapes the next character.
.IP
This is very useful for overriding
the default terminal settings without having to do an \fIstty\fP every time
an \fIxterm\fP is started.
Note, however, that the stty program on a given host may use different
keywords; \fIxterm\fR's table is built-in.
.TP 8
.B "useInsertMode (\fPclass\fB UseInsertMode)"
Force use of insert mode by adding appropriate entries to the TERMCAP
environment variable.
This is useful if the system termcap is broken.
The default is ``false.''
.TP 8
.B "utmpInhibit (\fPclass\fB UtmpInhibit)"
Specifies whether or not \fIxterm\fP should try to record the user's terminal
in
the system \fIutmp\fP log file.
.TP 8
.B "waitForMap (\fPclass\fB WaitForMap)"
Specifies whether or not \fIxterm\fP should wait for the initial window map
before starting the subprocess.
The default is ``false.''
.TP 8
.B "zIconBeep (\fPclass\fB ZIconBeep)"
Same as -ziconbeep command line argument.
If the value of this resource is non-zero, xterms that produce output
while iconified will cause an XBell sound at the given volume
and have "***" prepended to their icon titles.
Most window managers will detect this change immediately, showing you
which window has the output.
(A similar feature was in x10 \fIxterm\fR.)
The default is ``false.''
.
.PP
The following resources are specified as part
of the \fIvt100\fP widget (class \fIVT100\fP):
These are specified by patterns such as "\fBXTerm.vt100.\fP\fINAME\fP":
.TP 8
.B "activeIcon (\fPclass\fB ActiveIcon)"
Specifies whether or not active icon windows are to be used when the
\fIxterm\fP window is iconified, if this feature is compiled into \fIxterm\fR.
The active icon is a miniature representation of the content of the
window and will update as the content changes.
Not all window managers
necessarily support application icon windows.
Some window managers
will allow you to enter keystrokes into the active icon window.
The default is ``false.''
.TP 8
.B "allowC1Printable (\fPclass\fB AllowC1Printable)"
If true, overrides the mapping of C1 controls
(codes 128-159) to make them be treated
as if they were printable characters.
Although this corresponds to no particular standard,
some users insist it is a VT100.
The default is ``false.''
.TP 8
.B "allowSendEvents (\fPclass\fB AllowSendEvents)"
Specifies whether or not synthetic key and button events (generated using
the X protocol SendEvent request) should be interpreted or discarded.
The default is ``false'' meaning they are discarded.
Note that allowing
such events creates a very large security hole.
The default is ``false.''
.TP
.B "allowWindowOps (\fPclass\fB AllowWindowOps)"
Specifies whether extended window control sequences (as used in dtterm)
for should be allowed.
The default is ``true.''
.TP 8
.B "alwaysHighlight (\fPclass\fB AlwaysHighlight)"
Specifies whether or not \fIxterm\fP should always display a highlighted
text cursor.
By default (if this resource is false),
a hollow text cursor is displayed whenever the
pointer moves out of the window or the window loses the input focus.
The default is ``false.''
.TP 8
.B "alwaysUseMods (\fPclass\fB AlwaysUseMods)"
Override the \fBnumLock\fP resource, telling \fIxterm\fR to use the Alt and Meta
modifiers to construct parameters for function key sequences even if
those modifiers appear in the translations resource.
The default is ``false.''
.TP 8
.B "answerbackString (\fPclass\fB AnswerbackString)"
Specifies the string that \fIxterm\fR sends in response to an ENQ (control/E)
character from the host.
The default is a blank string, i.e., ``''.
A hardware VT100 implements this feature as a setup option.
.TP 8
.B "appcursorDefault (\fPclass\fB AppcursorDefault)"
If ``true,'' the cursor keys are initially in application mode.
This is the same as the VT102 private DECCKM mode,
The default is ``false.''
.TP 8
.B "appkeypadDefault (\fPclass\fB AppkeypadDefault)"
If ``true,'' the keypad keys are initially in application mode.
The default is ``false.''
.TP 8
.B "autoWrap (\fPclass\fB AutoWrap)"
Specifies whether or not auto-wraparound should be enabled.
This is the same as the VT102 DECAWM.
The
default is ``true.''
.TP 8
.B "awaitInput (\fPclass\fB AwaitInput)"
Specifies whether or not the \fIxterm\fR uses a 50 millisecond timeout to
await input (i.e., to support the Xaw3d arrow scrollbar).
The default is ``false.''
.TP 8
.B "backarrowKey (\fPclass\fB BackarrowKey)"
Specifies whether the backarrow key transmits
a backspace (8)
or delete (127) character.
This corresponds to the DECBKM control sequence.
The default (backspace) is ``true.''
Pressing the control key toggles this behavior.
.TP 8
.B "background (\fPclass\fB Background)"
Specifies the color to use for the background of the window.
The default is
``white.''
.TP 8
.B "bellSuppressTime (\fPclass\fB BellSuppressTime)"
Number of milliseconds after a bell command is sent during which additional
bells will be suppressed.
Default is 200.
If set non-zero,
additional bells
will also be suppressed until the server reports that processing of
the first bell has been completed; this feature is most useful with
the visible bell.
.TP 8
.B "boldColors (\fPclass\fB ColorMode)"
Specifies whether to combine bold attribute with colors like the IBM PC,
i.e., map colors 0 through 7 to colors 8 through 15.
These normally are the brighter versions of the first 8 colors, hence bold.
The default is ``true.''
.TP 8
.B "boldFont (\fPclass\fB BoldFont)"
Specifies the name of the bold font to use instead of overstriking.
There is no default for this resource.
.TP 8
.B "boldMode (\fPclass\fB BoldMode)"
This specifies whether or not text with the bold attribute should be
overstruck to simulate bold fonts if the resolved bold font is the
same as the normal font.
It may be desirable to disable bold fonts when color is being
used for the bold attribute.
Note that \fIxterm\fP has one bold font which you may set explicitly.
It attempts to match a bold font for the other font selections
(\fBfont1\fP through \fBfont6\fP).
If the normal and bold fonts are distinct, this resource has no effect.
The default is ``true.''
.IP
Although \fIxterm\fP attempts to match a bold font for other font selections,
the font server may not cooperate.
Since X11R6, bitmap fonts have been scaled.
The font server claims to provide the bold font that \fIxterm\fP requests,
but the result is not always readable.
XFree86 provides a feature which can be used to suppress the scaling.
In the X server's configuration file (e.g., "/etc/X11/XFree86"), you
can add ":unscaled" to the end of the directory specification for the
"misc" fonts, which comprise the fixed-pitch fonts that are used by \fIxterm\fP.
For example
.RS
	FontPath	"/usr/lib/X11/fonts/misc/"
.RE
.IP
would become
.RS
	FontPath	"/usr/lib/X11/fonts/misc/:unscaled"
.RE
.IP
Depending on your configuration, the font server may have its own configuration
file.
The same ":unscaled" can be added to its configuration file at the
end of the directory specification for "misc".
.TP 8
.B "brokenLinuxOSC (\fPclass\fB BrokenLinuxOSC)"
If true, \fIxterm\fP applies a workaround to ignore malformed control
sequences that a Linux script might send.
Compare the palette control sequences documented in \fIconsole_codes\fR
with ECMA-48.
The default is ``true.''
.TP 8
.B "brokenSelections (\fPclass\fB BrokenSelections)"
If true, \fIxterm\fP in 8-bit mode will interpret
.B STRING
selections as carrying text in the current locale's encoding.
Normally
.B STRING
selections carry ISO-8859-1 encoded text.
Setting this resource to
``true'' violates the ICCCM; it may, however, be useful for interacting
with some broken X clients.
The default is ``false.''
.TP 8
.B "brokenStringTerm (\fPclass\fB BrokenStringTerm)"
provides a work-around for some ISDN routers which start an application
control string without completing it.
Set this to ``true'' if \fIxterm\fP appears to freeze when connecting.
The default is ``false.''
.TP 8
.B "c132 (\fPclass\fB C132)"
Specifies whether or not the VT102 DECCOLM escape sequence,
used to switch between 80 and 132 columns, should be honored.
The default is ``false.''
.TP 8
.B "cacheDoublesize (\fPclass\fB CacheDoublesize)"
Specifies the maximum number of double-sized fonts which are cached by
\fIxterm\fR.
The default (8) may be too large for some X terminals with limited memory.
Set this to zero to disable doublesize fonts altogether.
.TP 8
.B "charClass (\fPclass\fB CharClass)"
Specifies comma-separated lists of character class bindings of the form
[\fIlow\fP-]\fIhigh\fP:\fIvalue\fP.
These are used in determining which
sets of characters should be treated the same when doing cut and paste.
See the CHARACTER CLASSES section.
.TP 8
.B "cjkWidth (\fPclass\fB CjkWidth)"
Specifies whether \fIxterm\fP should follow
the traditional East Asian width convention.
When turned on, characters with East Asian Ambiguous (A) category in UTR
11 have a column width of 2.
You may have to set this option to ``true''
if you have some old East Asian terminal based programs that assume that
line-drawing characters have a column width of 2.
The default is ``false.''
.TP 8
.B "color0 (\fPclass\fB Color0)"
.TP 8
.B "color1 (\fPclass\fB Color1)"
.TP 8
.B "color2 (\fPclass\fB Color2)"
.TP 8
.B "color3 (\fPclass\fB Color3)"
.TP 8
.B "color4 (\fPclass\fB Color4)"
.TP 8
.B "color5 (\fPclass\fB Color5)"
.TP 8
.B "color6 (\fPclass\fB Color6)"
.TP 8
.B "color7 (\fPclass\fB Color7)"
These specify the colors for the ISO 6429 extension.
The defaults are,
respectively,
black,
red3,
green3,
yellow3,
a customizable dark blue,
magenta3,
cyan3,
and
gray90.
The default shades of color are chosen to allow the colors 8-15
to be used as brighter versions.
.TP 8
.B "color8 (\fPclass\fB Color8)"
.TP 8
.B "color9 (\fPclass\fB Color9)"
.TP 8
.B "color10 (\fPclass\fB Color10)"
.TP 8
.B "color11 (\fPclass\fB Color11)"
.TP 8
.B "color12 (\fPclass\fB Color12)"
.TP 8
.B "color13 (\fPclass\fB Color13)"
.TP 8
.B "color14 (\fPclass\fB Color14)"
.TP 8
.B "color15 (\fPclass\fB Color15)"
These specify the colors for the ISO 6429 extension if the bold attribute
is also enabled.
The default resource values are respectively,
gray30,
red,
green,
yellow,
a customizable light blue,
magenta,
cyan,
and
white.
.TP 8
.B "color16 (\fPclass\fB Color16)"
.TP 8
through
.TP 8
.B "color255 (\fPclass\fB Color255)"
These specify the colors for the 256-color extension.
The default resource values
are for colors 16 through 231 to make a 6x6x6 color cube, and colors
232 through 255 to make a grayscale ramp.
.TP 8
.B "colorAttrMode (\fPclass\fB ColorAttrMode)"
Specifies whether ``colorBD'', ``colorBL'', ``colorUL'', and
``colorRV'' should override ANSI colors.
If not, these are displayed only when no ANSI colors
have been set for the corresponding position.
The default is ``false.''
.TP 8
.B "colorBD (\fPclass\fB ColorBD)"
This specifies the color to use to display bold characters if
the ``colorBDMode'' resource is enabled.
The default is ``XtDefaultForeground.''
.TP 8
.B "colorBDMode (\fPclass\fB ColorAttrMode)"
Specifies whether characters with the bold attribute should be displayed in
color or as bold characters.
Note that setting \fBcolorMode\fR off disables
all colors, including bold.
The default is ``false.''
.TP 8
.B "colorBL (\fPclass\fB ColorBL)"
This specifies the color to use to display blink characters if
the ``colorBLMode'' resource is enabled.
The default is ``XtDefaultForeground.''
.TP 8
.B "colorBLMode (\fPclass\fB ColorAttrMode)"
Specifies whether characters with the blink attribute should be displayed in
color.
Note that setting \fBcolorMode\fR off disables all colors, including this.
The default is ``false.''
.TP 8
.B "colorMode (\fPclass\fB ColorMode)"
Specifies whether or not recognition of ANSI (ISO 6429)
color change escape sequences should be enabled.
The default is ``true.''
.TP 8
.B "colorRV (\fPclass\fB ColorRV)"
This specifies the color to use to display reverse characters if
the ``colorRVMode'' resource is enabled.
The default is ``XtDefaultForeground.''
.TP 8
.B "colorRVMode (\fPclass\fB ColorAttrMode)"
Specifies whether characters with the reverse attribute should be displayed in
color.
Note that setting \fBcolorMode\fR off disables all colors, including this.
The default is ``false.''
.TP 8
.B "colorUL (\fPclass\fB ColorUL)"
This specifies the color to use to display underlined characters if
the ``colorULMode'' resource is enabled.
The default is ``XtDefaultForeground.''
.TP 8
.B "colorULMode (\fPclass\fB ColorAttrMode)"
Specifies whether characters with the underline attribute should be displayed
in color or as underlined characters.
Note that setting \fBcolorMode\fR off
disables all colors, including underlining.
The default is ``false.''
.TP 8
.B "ctrlFKeys (\fPclass\fB CtrlFKeys)"
In VT220 keyboard mode (see \fBsunKeyboard\fP resource),
specifies the amount by which to shift F1-F12 given a control modifier (CTRL).
This allows you to generate key symbols for F10-F20 on a Sun/PC keyboard.
The default is ``10'', which means that CTRL F1 generates the key
symbol for F11.
.TP 8
.B "curses (\fPclass\fB Curses)"
Specifies whether or not the last column bug in
.IR more (1)
should be worked around.
See the \fB-cu\fP option for details.
The default is ``false.''
.TP 8
.B "cursorBlink (\fPclass\fB CursorBlink)"
Specifies whether to make the cursor blink.
The default is ``false.''
.TP 8
.B "cursorColor (\fPclass\fB CursorColor)"
Specifies the color to use for the text cursor.
The default is ``black.''
.TP 8
.B "cursorOffTime (\fPclass\fB CursorOffTime)"
Specifies the duration of the "off" part of the cursor blink cycle-time
in milliseconds.
The same timer is used for text blinking.
The default is 300.
.TP 8
.B "cursorOnTime (\fPclass\fB CursorOnTime)"
Specifies the duration of the "on" part of the cursor blink cycle-time,
in milliseconds.
The same timer is used for text blinking.
The default is 600.
.TP 8
.B "cutNewline (\fPclass\fB CutNewline)"
If ``false'', triple clicking to select a line does not include the Newline
at the end of the line.
If ``true'', the Newline is selected.
The default is ``true.''
.TP 8
.B "cutToBeginningOfLine (\fPclass\fB CutToBeginningOfLine)"
If ``false'', triple clicking to select a line selects only from the
current word forward.
If ``true'', the entire line is selected.
The default is ``true.''
.TP 8
.B "decTerminalID (\fPclass\fB DecTerminalID)"
Specifies the emulation level (100=VT100, 220=VT220, etc.), used to determine
the type of response to a DA control sequence.
Leading non-digit characters are ignored, e.g., "vt100" and "100" are the same.
The default is 100.
.TP 8
.B "deleteIsDEL (\fPclass\fB DeleteIsDEL)"
Specifies whether the Delete key on the editing keypad should send DEL (127)
or the VT220-style Remove escape sequence.
The default is ``false,'' for the latter.
.TP 8
.B "dynamicColors (\fPclass\fB DynamicColors)"
Specifies whether or not escape sequences to change colors assigned to
different attributes are recognized.
.TP 8
.B "eightBitControl (\fPclass\fB EightBitControl\fP)"
Specifies whether or not control sequences sent by the
terminal should be eight-bit characters or escape sequences.
The default is ``false.''
.TP 8
.B "eightBitInput (\fPclass\fB EightBitInput\fP)"
If ``true'', Meta characters
(a character combined with the \fIkeys\fP modifier key)
input from the keyboard are presented as a
single character with the eighth bit turned on.
The terminal is put into 8-bit mode.
If ``false'', Meta characters are converted into a two-character
sequence with the character itself preceded by ESC.
The terminal is put into 7-bit mode.
The \fBmetaSendsEscape\fP resource may override this.
The default is ``true.''
.IP
Note that the \fIAlt\fP key is not necessarily the same as the
\fIMeta\fP modifier.
\fIxmodmap\fP lists your key modifiers.
X defines modifiers for shift, (caps) lock and control,
as well as 5 additional modifiers which are generally used to configure
key modifiers.
\fIxterm\fP inspects the same information to find the modifier associated
with either \fIMeta\fP key (left or right),
and uses that key as the \fIMeta\fP modifier.
It also looks for the NumLock key,
to recognize the modifier which is associated with that.
.IP
If your \fIxmodmap\fP configuration
uses the same keycodes for Alt- and Meta-keys,
\fIxterm\fP will only see the Alt-key definitions, since those are tested
before Meta-keys.
NumLock is tested first.
It is important to keep these keys distinct;
otherwise some of \fIxterm\fP's functionality is not available.
.TP 8
.B "eightBitOutput (\fPclass\fB EightBitOutput\fP)"
Specifies whether or not eight-bit characters sent from the host should be
accepted as is or stripped when printed.
The default is ``true,''
which means that they are accepted as is.
.TP 8
.B "faceName (\fPclass\fB FaceName)"
Specify the pattern for fonts selected from the FreeType
library if support for that library was compiled into \fIxterm\fR.
There is no default.
If not specified,
or if there is no match for both normal and bold fonts,
\fIxterm\fR uses the \fBfont\fP and related resources.
.TP 8
.B "faceNameDoublesize (\fPclass\fB FaceNameDoublesize)"
Specify an double-width font for cases where an application requires
this, e.g., in CJK applications.
There is no default.
If the application uses double-wide characters and this resource is not given,
\fIxterm\fP  will use a scaled version of the font given by \fBfaceName\fP.
.TP 8
.B "faceSize (\fPclass\fB FaceSize)"
Specify the pointsize for fonts selected from the FreeType
library if support for that library was compiled into \fIxterm\fR.
The default is ``14.''
.TP 8
.B "font (\fPclass\fB Font)"
Specifies the name of the normal font.
The default is ``fixed.''
.IP
See the discussion of the \fBlocale\fP resource,
which describes how this font may be overridden.
.IP
NOTE: some resource files use patterns such as
.RS
*font: fixed
.RE
.IP
which are overly broad, affecting both
.RS
xterm.vt100.font
.RE
.IP
and
.RS
xterm.vt100..utf8fonts.font
.RE
.IP
which is probably not what you intended.
.TP 8
.B "font1 (\fPclass\fB Font1)"
Specifies the name of the first alternative font.
.TP 8
.B "font2 (\fPclass\fB Font2)"
Specifies the name of the second alternative font.
.TP 8
.B "font3 (\fPclass\fB Font3)"
Specifies the name of the third alternative font.
.TP 8
.B "font4 (\fPclass\fB Font4)"
Specifies the name of the fourth alternative font.
.TP 8
.B "font5 (\fPclass\fB Font5)"
Specifies the name of the fifth alternative font.
.TP 8
.B "font6 (\fPclass\fB Font6)"
Specifies the name of the sixth alternative font.
.TP 8
.B "fontDoublesize (\fPclass\fB FontDoublesize)"
Specifies whether \fIxterm\fP should attempt to use font scaling to draw
doublesize characters.
Some older font servers cannot do this properly, will return misleading
font metrics.
The default is ``true''.
If disabled, \fIxterm\fP will simulate doublesize characters by drawing
normal characters with spaces between them.
.TP 8
.B "forceBoxChars (\fPclass\fB ForceBoxChars)"
Specifies whether \fIxterm\fP should assume the normal and bold fonts
have VT100 line-drawing characters.
The fixed-pitch fonts used by \fIxterm\fP
normally have the VT100 line-drawing glyphs in cells 1-31.
Other fixed-pitch fonts may be more attractive, but lack these glyphs.
If ``false'', \fIxterm\fP will check for missing glyphs in cells 1-31
and make line-drawing characters directly.
If ``true'', \fIxterm\fP uses whatever is in cells 1-31 without checking.
The default is ``false.''
.TP 8
.B "foreground (\fPclass\fB Foreground)"
Specifies the color to use for displaying text in the window.
Setting the
class name instead of the instance name is an easy way to have everything
that would normally appear in the text color change color.
The default
is ``black.''
.TP 8
.B "freeBoldBox (\fPclass\fB freeBoldBox)"
Specifies whether \fIxterm\fP should assume the bounding boxes for
normal and bold fonts are compatible.
If ``false'', \fIxterm\fP compares them and will reject choices of
bold fonts that do not match the size of the normal font.
The default is ``false'', which means that the comparison is performed.
.TP 8
.B "geometry (\fPclass\fB Geometry)"
Specifies the preferred size and position of the VT102 window.
There is no default for this resource.
.TP 8
.B "highlightColor (\fPclass\fB HighlightColor)"
Specifies the color to use for the background of selected or otherwise
highlighted text.
If not specified, reverse video is used.
The default is ``XtDefaultForeground.''
.TP 8
.B "highlightSelection (\fPclass\fB HighlightSelection)"
If ``false'', selecting with the mouse highlights all positions on the screen
between the beginning of the selection and the current position.
If ``true'', \fIxterm\fP highlights only the positions that contain text that
can be selected.
The default is ``false.''
.IP
Depending on the way your applications write to the screen, there may
be trailing blanks on a line.
\fIXterm\fP stores data as it is shown on the screen.
Erasing the display changes the internal state of each cell
so it is not considered a blank for the purpose of selection.
Blanks written since the last erase are selectable.
If you do not wish to have trailing blanks in a selection,
use the \fBtrimSelection\fP resource.
.TP 8
.B "hpLowerleftBugCompat (\fPclass\fB HpLowerleftBugCompat)"
Specifies whether to work around a bug in HP's \fIxdb\fP,
which ignores termcap and always sends
ESC F to move to the lower left corner.
``true'' causes \fIxterm\fP to interpret ESC F as a request to move to the
lower left corner of the screen.
The default is ``false.''
.TP 8
.B "i18nSelections (\fPclass\fB I18nSelections)"
If false, \fIxterm\fP will never request the targets
.B COMPOUND_TEXT
or
.BR TEXT .
The default is ``true.'' It may be set to false in order to work around
ICCCM violations by other X clients.
.TP 8
.B "iconBorderColor (\fPclass\fB BorderColor)"
Specifies the border color for the active icon window if this feature
is compiled into \fIxterm\fR.
Not all window managers will make the icon
border visible.
.TP 8
.B "iconBorderWidth (\fPclass\fB BorderWidth)"
Specifies the border width for the active icon window if this feature
is compiled into \fIxterm\fR.
The default is 0 (no border).
Not all window
managers will make the border visible.
.TP 8
.B "iconFont (\fPclass\fB IconFont)"
Specifies the font for the miniature active icon window, if this feature
is compiled into \fIxterm\fR.
The default is "nil2".
.TP 8
.B "internalBorder (\fPclass\fB BorderWidth)"
Specifies the number of pixels between the characters and the window border.
The default is 2.
.TP 8
.B "jumpScroll (\fPclass\fB JumpScroll)"
Specifies whether or not jump scroll should be used.
This corresponds to the VT102 DECSCLM private mode.
The default is ``true.''
.TP 8
.B "keyboardDialect (\fPclass\fB KeyboardDialect)"
Specifies the initial keyboard dialect, as well as the default value when
the terminal is reset.
The value given is the same as the final character in the control sequences
which change character sets.
The default is ``B'', which corresponds to US ASCII.
.TP 8
.B "\fIname\fP\fBKeymap\fP (class\fB \fIName\fP\fBKeymap\fP)"
See the discussion of the \fBkeymap()\fP action.
.TP 8
.B "limitResize (\fPclass\fB LimitResize)"
Limits resizing of the screen via control sequence to a given multiple of
the display dimensions.
The default is ``1''.
.TP 8
.B "locale (\fPclass\fB Locale)"
Specifies how to use \fIluit\fR, an encoding converter between UTF-8
and locale encodings.
The resource value (ignoring case) may be:
.RS
.TP 4
.I true
\fIxterm\fR will use the
encoding specified by the users' LC_CTYPE locale (i.e., LC_ALL,
LC_CTYPE, or LANG variables) as far as possible.
This is realized
by always enabling UTF-8 mode and invoking \fIluit\fR in non-UTF-8
locales.
.TP
.I medium
\fIxterm\fR will follow users'
LC_CTYPE locale only for UTF-8, east Asian, and Thai locales,
where the encodings were not supported by conventional 8bit mode
with changing fonts.
For other locales, \fIxterm\fR will use conventional 8bit mode.
.TP
.I checkfont
If mini-luit is compiled-in, \fIxterm\fR will check if a Unicode font has
been specified.  If so, it checks if the character encoding for the
current locale is POSIX, Latin-1 or Latin-9, uses the appropriate
mapping to support those with the Unicode font.
For other encodings, \fIxterm\fR assumes that UTF-8 encoding is required.
.TP
.I false
\fIxterm\fR will use conventional 8bit mode
or UTF-8 mode according to \fButf8\fR resource or \fB-u8\fP option.
.RE
.IP
Any other value, e.g., ``UTF-8'' or ``ISO8859-2'',
is assumed to be an encoding name;
\fIluit\fR will be invoked to support the encoding.
The actual list of supported encodings depends on \fIluit\fR.
The default is ``medium''.
.IP
Regardless of your locale and encoding,
you need an ISO-10646-1 font to display the result.
Your configuration may not include this font,
or locale-support by \fIxterm\fP may not be needed.
At startup, \fIxterm\fP uses a mechanism equivalent to
the \fBload-vt-fonts(utf8Fonts,\ Utf8Fonts)\fP action
to load font name subresources of the VT100 widget.
That is,
resource patterns such as "\fB*vt100.utf8Fonts.font\fP" will be loaded,
and (if this resource is enabled), override the normal fonts.
If no subresources are found,
the normal fonts such as "\fB*vt100.font\fP", etc., are used.
The resource files distributed with \fIxterm\fP use ISO-10646-1 fonts,
but do not rely on them unless you are using the locale mechanism.
.TP 8
.B "localeFilter (\fPclass\fB LocaleFilter)"
Specifies the file name for the encoding converter from/to locale
encodings and UTF-8 which is used with the \fB-lc\fR option or \fBlocale\fR resource.
The help message shown by ``xterm -help'' lists the default value,
which depends on your system configuration.
.TP 8
.B "loginShell (\fPclass\fB LoginShell)"
Specifies whether or not the shell to be run in the window should be started
as a login shell.
The default is ``false.''
.TP 8
.B "marginBell (\fPclass\fB MarginBell)"
Specifies whether or not the bell should be rung when the user types near the
right margin.
The default is ``false.''
.TP 8
.B "metaSendsEscape (\fPclass\fB MetaSendsEscape\fP)"
If ``true'', Meta characters
(a character combined with the \fIMeta\fP modifier key)
are converted into a two-character
sequence with the character itself preceded by ESC.
This applies as well to function key control sequences, unless \fIxterm\fP
sees that \fBMeta\fP is used in your key translations.
If ``false'', Meta characters input from the keyboard are handled according
to the \fBeightBitInput\fP resource.
The default is ``false.''
.TP 8
.B "modifyCursorKeys (\fPclass\fB ModifyCursorKeys\fP)"
Tells how to handle the special case where
Control-, Shift-, Alt- or Meta-modifiers are used to add a parameter to
the escape sequence returned by a cursor-key.
Set it to 0 to use the old/obsolete behavior.
Set it to 1 to prefix modified sequences with CSI.
Set it to 2 to force the modifier to be the second parameter.
Set it to 3 to mark the sequence with a '>' to hint that it is private.
The default is ``2''.
.TP 8
.B "multiClickTime (\fPclass\fB MultiClickTime)"
Specifies the maximum time in milliseconds between multi-click select
events.
The default is 250 milliseconds.
.TP 8
.B "multiScroll (\fPclass\fB MultiScroll)"
Specifies whether or not scrolling should be done asynchronously.
The default is ``false.''
.TP 8
.B "nMarginBell (\fPclass\fB Column)"
Specifies the number of characters from the right margin at which the margin
bell should be rung, when enabled.
.TP 8
.B "numLock (\fPclass\fB NumLock)"
If ``true'', \fIxterm\fR checks if NumLock is used as a modifier (see \fIxmodmap\fP(1)).
If so, this modifier is used to simplify the logic when implementing special
NumLock for the \fBsunKeyboard\fP resource.
Also (when \fBsunKeyboard\fP is false), similar logic is used to find the
modifier associated with the left and right Alt keys.
The default is ``true.''
.TP 8
.B "oldXtermFKeys (\fPclass\fB OldXtermFKeys)"
If ``true'', \fIxterm\fR will use old-style control sequences for function keys F1 to F4,
for compatibility with X Consortium \fIxterm\fR.
Otherwise, it uses the VT100-style
codes for PF1 to PF4.
The default is ``false.''
.TP 8
.B "pointerColor (\fPclass\fB PointerColor)"
Specifies the foreground color of the pointer.
The default is
``XtDefaultForeground.''
.TP 8
.B "pointerColorBackground (\fPclass\fB PointerColorBackground)"
Specifies the background color of the pointer.
The default is
``XtDefaultBackground.''
.TP 8
.B "pointerShape (\fPclass\fB Cursor)"
Specifies the name of the shape of the pointer.
The default is ``xterm.''
.TP 8
.B "popOnBell (\fPclass\fB PopOnBell)"
Specifies whether the window whould be raised when Control-G is
received.
The default is ``false.''
.TP 8
.B "printAttributes (\fPclass\fB PrintAttributes)"
Specifies whether to print graphic attributes along with the text.
A real DEC VTxxx terminal will print the underline, highlighting codes
but your printer may not handle these.
A ``0'' disables the attributes.
A ``1'' prints the normal set of attributes (bold, underline, inverse and blink)
as VT100-style control sequences.
A ``2'' prints ANSI color attributes as well.
The default is ``1.''
.TP 8
.B "printerAutoClose (\fPclass\fB PrinterAutoClose)"
If ``true'', \fIxterm\fR will close the printer (a pipe) when the application switches
the printer offline with a Media Copy command.
The default is ``false.''
.TP 8
.B "printerCommand (\fPclass\fB PrinterCommand)"
Specifies a shell command to which
.I xterm
will open a pipe when the first
MC (Media Copy) command is initiated.
The default is ``lpr.''
If the resource value is given as a blank string, the printer is disabled.
.TP 8
.B "printerControlMode (\fPclass\fB PrinterControlMode)"
Specifies the printer control mode.
A ``1'' selects autoprint mode, which causes
.I xterm
to print a line from the screen when you move the cursor off that
line with a line feed, form feed or vertical tab character, or an
autowrap occurs.
Autoprint mode is overridden by printer controller mode (a ``2''),
which causes all of the output to be directed to the printer.
The default is ``0.''
.TP 8
.B "printerExtent (\fPclass\fB PrinterExtent)"
Controls whether a print page function will print the entire page (true), or
only the the portion within the scrolling margins (false).
The default is ``false.''
.TP 8
.B "printerFormFeed (\fPclass\fB PrinterFormFeed)"
Controls whether a form feed is sent to the printer at the end of a print
page function.
The default is ``false.''
.TP 8
.B "renderFont (\fPclass\fB RenderFont)"
If \fIxterm\fR is built with the Xft library,
this controls whether the \fBfaceName\fR resource is used.
The default is ``true.''
.TP 8
.B "resizeGravity (\fPclass\fB ResizeGravity)"
Affects the behavior when the window is resized to be taller or
shorter.
\fBNorthWest\fP
specifies that the top line of text on the screen stay fixed.
If the window
is made shorter, lines are dropped from the bottom; if the window is
made taller, blank lines are added at the bottom.
This is compatible
with the behavior in R4.
\fBSouthWest\fP (the default) specifies that
the bottom line of text on the screen stay fixed.
If the window is
made taller, additional saved lines will be scrolled down onto the
screen; if the window is made shorter, lines will be scrolled off the
top of the screen, and the top saved lines will be dropped.
.TP 8
.B "reverseVideo (\fPclass\fB ReverseVideo)"
Specifies whether or not reverse video should be simulated.
The default is
``false.''
.TP 8
.B "reverseWrap (\fPclass\fB ReverseWrap)"
Specifies whether or not reverse-wraparound should be enabled.
This corresponds to \fIxterm\fP's private mode 45.
The default is
``false.''
.TP 8
.B "rightScrollBar (\fPclass\fB RightScrollBar)"
Specifies whether or not the scrollbar should be displayed on the right
rather than the left.
The default is ``false.''
.TP 8
.B "saveLines (\fPclass\fB SaveLines)"
Specifies the number of lines to save beyond the top of the screen when a
scrollbar is turned on.
The default is 64.
.TP 8
.B "scrollBar (\fPclass\fB ScrollBar)"
Specifies whether or not the scrollbar should be displayed.
The default is
``false.''
.TP 8
.B "scrollKey (\fPclass\fB ScrollCond)"
Specifies whether or not pressing a key should automatically cause the
scrollbar to go to the bottom of the scrolling region.
This corresponds to \fIxterm\fP's private mode 1011.
The default is
``false.''
.TP 8
.B "scrollLines (\fPclass\fB ScrollLines)"
Specifies the number of lines that the \fIscroll-back\fP and
\fIscroll-forw\fP actions should use as a default.
The default value is 1.
.TP 8
.B "scrollTtyOutput (\fPclass\fB ScrollCond)"
Specifies whether or not output to the terminal should automatically cause
the scrollbar to go to the bottom of the scrolling region.
The default is ``true.''
.TP 8
.B "shiftFonts (\fPclass\fB ShiftFonts)"
Specifies whether to enable the actions
\fBlarger-vt-font()\fP and
\fBsmaller-vt-font()\fP, which are normally bound to
the shifted KP_Add and KP_Subtract.
The default is ``true.''
.TP 8
.B "showBlinkAsBold (\fPclass\fB ShowBlinkAsBold)"
Tells \fIxterm\fP whether to display text with blink-attribute the same
as bold.
If \fIxterm\fP has not been configured to support blinking text,
the default is ``true.'', which corresponds to older versions of \fIxterm\fP,
otherwise the default is ``false.''
.TP 8
.B "showMissingGlyphs (\fPclass\fB ShowMissingGlyphs)"
Tells \fIxterm\fP whether to display a box outlining places where
a character has been used that the font does not represent.
The default is ``false.''
.TP 8
.B "signalInhibit (\fPclass\fB SignalInhibit)"
Specifies whether or not the entries in the ``Main Options'' menu for sending
signals to \fIxterm\fP should be disallowed.
The default is ``false.''
.TP 8
.B "tekGeometry (\fPclass\fB Geometry)"
Specifies the preferred size and position of the Tektronix window.
There is no default for this resource.
.TP 8
.B "tekInhibit (\fPclass\fB TekInhibit)"
Specifies whether or not
the escape sequence to enter
Tektronix mode should be ignored.
The default is
``false.''
.TP 8
.B "tekSmall (\fPclass\fB TekSmall)"
Specifies whether or not the Tektronix mode window should start in its smallest
size if no explicit geometry is given.
This is useful when running \fIxterm\fP
on displays with small screens.
The default is ``false.''
.TP 8
.B "tekStartup (\fPclass\fB TekStartup)"
Specifies whether or not \fIxterm\fP should start up in Tektronix mode.
The default is ``false.''
.TP 8
.B "tiXtraScroll (\fPclass\fB TiXtraScroll)"
Specifies whether \fIxterm\fP should scroll to a new page when processing
the \fIti\fP termcap entry, i.e., the private modes 47, 1047 or 1049.
This is only in effect if \fBtiteInhibit\fP is ``true'',
because the intent of this option is to provide a picture of the full-screen
application's display on the scrollback without wiping out the text that
would be shown before the application was initialized.
The default for this resource is ``false.''
.TP 8
.B "titeInhibit (\fPclass\fB TiteInhibit)"
Specifies whether or not \fIxterm\fP should remove \fIti\fP and \fIte\fP
termcap entries (used to switch between alternate screens on startup of many
screen-oriented programs) from the TERMCAP string.
If set,
\fIxterm\fP also ignores the escape sequence to switch to the
alternate screen.
\fIXterm\fP supports terminfo in a different way, supporting composite control
sequences (also known as private modes) 1047, 1048 and 1049 which have the same
effect as the original 47 control sequence.
The default for this resource is ``false.''
.\" -- resource does not work properly (forms/layout issues)
.\".TP 8
.\".B "toolBar (\fPclass\fB ToolBar)"
.\"Specifies whether or not the toolbar should be displayed.
.\"The default is
.\"``false.''
.TP 8
.B "translations (\fPclass\fB Translations)"
Specifies the key and button bindings for menus, selections, ``programmed
strings,'' etc.
The \fBtranslations\fP resource,
which provides much of \fIxterm\fP's configurability,
is a feature of the X Toolkit Intrinsics library (Xt).
See the \fBACTIONS\fP section.
.TP 8
.B "trimSelection (\fPclass\fB TrimSelection)"
If you set \fBhighlightSelection\fP,
you can see the text which is selected, including any trailing spaces.
Clearing the screen (or a line) resets it to a state containing no spaces.
Some lines may contain trailing spaces when an application writes them to
the screen.
However, you may not wish to paste lines with trailing spaces.
If this resource is true, \fIxterm\fP will trim trailing spaces from
text which is selected.
It does not affect spaces which result in a wrapped line, nor will it
trim the trailing newline from your selection.
The default is ``false.''
.TP 8
.B "underLine (\fPclass\fB UnderLine)"
This specifies whether or not text with the underline attribute should be
underlined.
It may be desirable to disable underlining when color is being
used for the underline attribute.
The default is ``true.''
.TP 8
.B "utf8 (\fPclass\fB Utf8)"
This specifies whether \fIxterm\fP will run in UTF-8 mode.
If you set this resource, \fIxterm\fP also sets the \fBwideChars\fP resource as a side-effect.
The resource is an integer, expected to range from 0 to 3:
.RS
.TP
0
UTF-8 mode is initially off.
Escape sequences for turning UTF-8 mode on/off are allowed.
.TP
1
UTF-8 mode is initially on.
Escape sequences for turning UTF-8 mode on/off are allowed.
.TP
2
The command-line option \fB-u8\fP sets the resource to this value.
Escape sequences for turning UTF-8 mode on/off are ignored.
.TP
3
This is the default value of the resource.
It is changed during initialization depending on
whether the \fBlocale\fP resource was set, to 0 or 2.
See the \fBlocale\fR resource for additional discussion of non-UTF-8 locales.
.RE
.IP
If you want to set the value of \fButf8\fP, it should be in this range.
Other nonzero values are treated the same a ``1'',
i.e., UTF-8 mode is initially on, and
escape sequences for turning UTF-8 mode on/off are allowed.
.TP 8
.B "utf8Fonts (\fPclass\fB Utf8Fonts)"
See the discussion of the \fBlocale\fP resource.
.TP 8
.B "veryBoldColors (\fPclass\fB VeryBoldColors)"
Specifies whether to combine video attributes with colors specified by
\fBcolorBD\fR, \fBcolorBL\fR and \fBcolorUL\fR.
The resource value is the sum of values for each attribute:
2 for underline,
4 for bold and
8 for blink.
The default is ``0.''
.TP 8
.B "visualBell (\fPclass\fB VisualBell)"
Specifies whether or not a visible bell (i.e., flashing) should be used instead
of an audible bell when Control-G is received.
The default is ``false.''
.TP 8
.B "visualBellDelay (\fPclass\fB VisualBellDelay)"
Number of milliseconds to delay when displaying a visual bell.
Default is 100.
If set to zero, no visual bell is displayed.
This is useful for very slow displays, e.g., an LCD display on a laptop.
.TP 8
.B "vt100Graphics (\fPclass\fB VT100Graphics)"
This specifies whether \fIxterm\fP will interpret VT100 graphic character
escape sequences while in UTF-8 mode.
The default is ``true'', to provide support for various legacy applications.
.TP 8
.B "wideBoldFont (\fPclass\fB WideBoldFont)"
This option specifies the font to be used for displaying bold wide text.
By default,
it will attempt to use a font twice as wide as the font that will be used to
draw bold text.
If no doublewidth font is found, it will improvise, by stretching
the bold font.
.TP 8
.B "wideChars (\fPclass\fB WideChars)"
Specifies if \fIxterm\fP should respond to control sequences that
process 16-bit characters.
The default is ``false.''
.TP 8
.B "wideFont (\fPclass\fB WideFont)"
This option specifies the font to be used for displaying wide text.
By default,
it will attempt to use a font twice as wide as the font that will be used to
draw normal text.
If no doublewidth font is found, it will improvise, by stretching
the normal font.
.TP 8
.B "ximFont (\fPclass\fB XimFont)"
This option specifies the font to be used for displaying the preedit string
in the "OverTheSpot" input method.
.IP
In "OverTheSpot" preedit type, the preedit (preconversion)
string is displayed at the position of the cursor.
It is the XIM server's responsibility to display the preedit string.
The XIM client must inform the XIM server of the cursor position.
For best results, the preedit string must be displayed with a proper font.
Therefore, \fIxterm\fP informs the XIM server of the proper font.
The font is be supplied by a "fontset", whose default value is "*".
This matches every font, the X library automatically chooses fonts with
proper charsets.
The \fBximFont\fP resource is provided to override this default font setting.
.
.PP
The following resources are specified
as part of the \fItek4014\fP widget (class \fITek4014\fP).
These are specified by patterns such as "\fBXTerm.tek4014.\fP\fINAME\fP":
.TP 8
.B "font2 (\fPclass\fB Font)"
Specifies font number 2 to use in the Tektronix window.
.TP 8
.B "font3 (\fPclass\fB Font)"
Specifies font number 3 to use in the Tektronix window.
.TP 8
.B "fontLarge (\fPclass\fB Font)"
Specifies the large font to use in the Tektronix window.
.TP 8
.B "fontSmall (\fPclass\fB Font)"
Specifies the small font to use in the Tektronix window.
.TP 8
.B "ginTerminator (\fPclass\fB GinTerminator)"
Specifies what character(s) should follow a GIN report or status report.
The possibilities are ``none,'' which sends no terminating characters,
``CRonly,'' which sends CR, and ``CR&EOT,'' which sends both CR and EOT.
The default is ``none.''
.TP 8
.B "height (\fPclass\fB Height)"
Specifies the height of the Tektronix window in pixels.
.TP 8
.B "initialFont (\fPclass\fB InitialFont)"
Specifies which of the four Tektronix fonts to use initially.
Values are the same as for the \fIset-tek-text\fP action.
The default is ``large.''
.TP 8
.B "width (\fPclass\fB Width)"
Specifies the width of the Tektronix window in pixels.
.
.PP
The resources that may be specified for the various menus are described in
the documentation for the Athena \fBSimpleMenu\fP widget.
The name and classes
of the entries in each of the menus are listed below.
Resources named "\fBline\fR\fIN\fR" where \fIN\fR is a number
are separators with class \fBSmeLine\fR.
.
.PP
The \fImainMenu\fP has the following entries:
.TP 8
.B "toolbar (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-toolbar(toggle)\fP action.
.TP 8
.B "securekbd (\fPclass\fB SmeBSB)"
This entry invokes the \fBsecure()\fP action.
.TP 8
.B "allowsends (\fPclass\fB SmeBSB)"
This entry invokes the \fBallow-send-events(toggle)\fP action.
.TP 8
.B "redraw (\fPclass\fB SmeBSB)"
This entry invokes the \fBredraw()\fP action.
.TP 8
.B "logging (\fPclass\fB SmeBSB)"
This entry invokes the \fBlogging(toggle)\fP action.
.TP 8
.B "print (\fPclass\fB SmeBSB)"
This entry invokes the \fBprint()\fP action.
.TP 8
.B "print-redir (\fPclass\fB SmeBSB)"
This entry invokes the \fBprint-redir()\fP action.
.TP 8
.B "8-bit-control (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-8-bit-control(toggle)\fP action.
.TP 8
.B "backarrow\ key (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-backarrow(toggle)\fP action.
.TP 8
.B "num-lock (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-num-lock(toggle)\fP action.
.TP 8
.B "meta-esc (\fPclass\fB SmeBSB)"
This entry invokes the \fBmeta-sends-escape(toggle)\fP action.
.TP 8
.B "delete-is-del (\fPclass\fB SmeBSB)"
This entry invokes the \fBdelete-is-del(toggle)\fP action.
.TP 8
.B "oldFunctionKeys (\fPclass\fB SmeBSB)"
This entry invokes the \fBold-function-keys(toggle)\fP action.
.TP 8
.B "hpFunctionKeys (\fPclass\fB SmeBSB)"
This entry invokes the \fBhp-function-keys(toggle)\fP action.
.TP 8
.B "scoFunctionKeys (\fPclass\fB SmeBSB)"
This entry invokes the \fBsco-function-keys(toggle)\fP action.
.TP 8
.B "sunFunctionKeys (\fPclass\fB SmeBSB)"
This entry invokes the \fBsun-function-keys(toggle)\fP action.
.TP 8
.B "sunKeyboard (\fPclass\fB SmeBSB)"
This entry invokes the \fBsunKeyboard(toggle)\fP action.
.TP 8
.B "suspend (\fPclass\fB SmeBSB)"
This entry invokes the \fBsend-signal(tstp)\fP action on systems that
support job control.
.TP 8
.B "continue (\fPclass\fB SmeBSB)"
This entry invokes the \fBsend-signal(cont)\fP action on systems that
support job control.
.TP 8
.B "interrupt (\fPclass\fB SmeBSB)"
This entry invokes the \fBsend-signal(int)\fP action.
.TP 8
.B "hangup (\fPclass\fB SmeBSB)"
This entry invokes the \fBsend-signal(hup)\fP action.
.TP 8
.B "terminate (\fPclass\fB SmeBSB)"
This entry invokes the \fBsend-signal(term)\fP action.
.TP 8
.B "kill (\fPclass\fB SmeBSB)"
This entry invokes the \fBsend-signal(kill)\fP action.
.TP 8
.B "quit (\fPclass\fB SmeBSB)"
This entry invokes the \fBquit()\fP action.
.
.PP
The \fIvtMenu\fP has the following entries:
.TP 8
.B "scrollbar (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-scrollbar(toggle)\fP action.
.TP 8
.B "jumpscroll (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-jumpscroll(toggle)\fP action.
.TP 8
.B "reversevideo (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-reverse-video(toggle)\fP action.
.TP 8
.B "autowrap (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-autowrap(toggle)\fP action.
.TP 8
.B "reversewrap (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-reversewrap(toggle)\fP action.
.TP 8
.B "autolinefeed (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-autolinefeed(toggle)\fP action.
.TP 8
.B "appcursor (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-appcursor(toggle)\fP action.
.TP 8
.B "appkeypad (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-appkeypad(toggle)\fP action.
.TP 8
.B "scrollkey (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-scroll-on-key(toggle)\fP action.
.TP 8
.B "scrollttyoutput (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-scroll-on-tty-output(toggle)\fP action.
.TP 8
.B "allow132 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-allow132(toggle)\fP action.
.TP 8
.B "cursesemul (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-cursesemul(toggle)\fP action.
.TP 8
.B "visualbell (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-visualbell(toggle)\fP action.
.TP 8
.B "poponbell (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-poponbell(toggle)\fP action.
.TP 8
.B "marginbell (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-marginbell(toggle)\fP action.
.TP 8
.B "cursorblink (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-cursorblink(toggle)\fP action.
.TP 8
.B "titeInhibit (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-titeInhibit(toggle)\fP action.
.TP 8
.B "activeicon (\fPclass\fB SmeBSB)"
This entry toggles active icons on and off if this feature was
compiled into \fIxterm\fP.
It is enabled only if \fIxterm\fP
was started with the command line option +ai or the \fBactiveIcon\fP
resource is set to ``True.''
.TP 8
.B "softreset (\fPclass\fB SmeBSB)"
This entry invokes the \fBsoft-reset()\fP action.
.TP 8
.B "hardreset (\fPclass\fB SmeBSB)"
This entry invokes the \fBhard-reset()\fP action.
.TP 8
.B "clearsavedlines (\fPclass\fB SmeBSB)"
This entry invokes the \fBclear-saved-lines()\fP action.
.TP 8
.B "tekshow (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-visibility(tek,toggle)\fP action.
.TP 8
.B "tekmode (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-terminal-type(tek)\fP action.
.TP 8
.B "vthide (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-visibility(vt,off)\fP action.
.TP 8
.B "altscreen (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-altscreen(toggle)\fP action.
.
.PP
The \fIfontMenu\fP has the following entries:
.TP 8
.B "fontdefault (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(d)\fP action.
.TP 8
.B "font1 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(1)\fP action.
.TP 8
.B "font2 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(2)\fP action.
.TP 8
.B "font3 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(3)\fP action.
.TP 8
.B "font4 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(4)\fP action.
.TP 8
.B "font5 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(5)\fP action.
.TP 8
.B "font6 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(6)\fP action.
.TP 8
.B "fontescape (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(e)\fP action.
.TP 8
.B "fontsel (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-vt-font(s)\fP action.
.TP 8
.B "font-linedrawing (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-font-linedrawing(s)\fP action.
.TP 8
.B "font-doublesize (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-font-doublesize(s)\fP action.
.TP 8
.B "render-font (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-render-font(s)\fP action.
.TP 8
.B "utf8-mode (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-utf8-mode(s)\fP action.
.
.PP
The \fItekMenu\fP has the following entries:
.TP 8
.B "tektextlarge (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-tek-text(l)\fP action.
.TP 8
.B "tektext2 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-tek-text(2)\fP action.
.TP 8
.B "tektext3 (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-tek-text(3)\fP action.
.TP 8
.B "tektextsmall (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-tek-text(s)\fP action.
.TP 8
.B "tekpage (\fPclass\fB SmeBSB)"
This entry invokes the \fBtek-page()\fP action.
.TP 8
.B "tekreset (\fPclass\fB SmeBSB)"
This entry invokes the \fBtek-reset()\fP action.
.TP 8
.B "tekcopy (\fPclass\fB SmeBSB)"
This entry invokes the \fBtek-copy()\fP action.
.TP 8
.B "vtshow (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-visibility(vt,toggle)\fP action.
.TP 8
.B "vtmode (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-terminal-type(vt)\fP action.
.TP 8
.B "tekhide (\fPclass\fB SmeBSB)"
This entry invokes the \fBset-visibility(tek,toggle)\fP action.
.
.PP
The following resources are useful when specified for the Athena Scrollbar
widget:
.TP 8
.B "thickness (\fPclass\fB Thickness)"
Specifies the width in pixels of the scrollbar.
.TP 8
.B "background (\fPclass\fB Background)"
Specifies the color to use for the background of the scrollbar.
.TP 8
.B "foreground (\fPclass\fB Foreground)"
Specifies the color to use for the foreground of the scrollbar.
The ``thumb''
of the scrollbar is a simple checkerboard pattern alternating pixels for
foreground and background color.
.
.
.SH "POINTER USAGE"
.
.PP
Once the VT102 window is created,
.I xterm
allows you to select text and copy it within the same or other windows.
.
.PP
The selection functions are invoked when the pointer buttons are used with no
modifiers, and when they are used with the ``shift'' key.
The assignment of the functions described below to keys and buttons may
be changed through the resource database; see \fBACTIONS\fP below.
.
.PP
Pointer button one (usually left) is used to save text into the cut buffer.
Move the cursor to beginning of the text,
and then hold the button down while moving the cursor to the end of the region
and releasing the button.
The selected text is highlighted and is saved in the global cut buffer
and made the PRIMARY selection when the button is released.
Double-clicking selects by words.
Triple-clicking
selects by lines.
Quadruple-clicking goes back to characters, etc.
Multiple-click is determined by the time from button up to
button down, so you can change the selection unit in the middle of a selection.
Logical words and lines selected by double- or triple-clicking may wrap
across more than one screen line if lines were wrapped by \fIxterm\fP
itself rather than by the application running in the window.
If the key/button bindings specify that an X selection is to be made,
\fIxterm\fP will leave the selected text highlighted for as long as it
is the selection owner.
.
.PP
Pointer button two (usually middle) `types' (pastes) the text from
the PRIMARY selection, if any, otherwise from
the cut buffer,
inserting it as keyboard input.
.
.PP
Pointer button three (usually right) extends the current selection.
(Without loss of generality,
you can swap ``right'' and ``left'' everywhere in the rest of this
paragraph.)  If pressed while closer to
the right edge of the selection than the left, it extends/contracts the
right edge of the selection.
If you contract the selection past
the left edge of the selection,
.I xterm
assumes you really meant the left edge, restores the original selection, then
extends/contracts the left edge of the selection.
Extension starts in the
selection unit mode
that the last selection or extension was performed in; you can multiple-click
to cycle through them.
.
.PP
By cutting and pasting pieces of text without trailing new lines,
you can take text from several places in different windows and form a command
to the shell, for example, or take output from a program and insert it into
your favorite editor.
Since cut buffers are globally shared among different applications,
you may regard each as a `file' whose contents you know.
The terminal emulator and other text programs should be treating it as if it
were a text file, i.e., the text is delimited by new lines.
.
.PP
The scroll region displays the position and amount of text currently showing
in the window (highlighted) relative to the amount of text actually saved.
As more text is saved (up to the maximum), the size of the highlighted area
decreases.
.
.PP
Clicking button one with the pointer in the scroll region moves the
adjacent line to the top of the display window.
.
.PP
Clicking button three moves the top line of the display window down to the
pointer position.
.
.PP
Clicking button two moves the display to a position in the saved text
that corresponds to the pointer's position in the scrollbar.
.
.PP
Unlike the VT102 window, the Tektronix window does not allow the copying of
text.
It does allow Tektronix GIN mode, and in this mode
the cursor will change from an arrow to a cross.
Pressing any key will send that key and the current coordinate of the
cross cursor.
Pressing button one, two, or three will return the letters `l', `m', and
`r', respectively.
If the `shift' key is pressed when a pointer button is pressed, the corresponding
upper case letter is sent.
To distinguish a pointer button from a key, the high bit of the character is
set (but this is bit is normally stripped unless the terminal mode is RAW;
see
.IR tty (4)
for details).
.
.
.SH MENUS
.
.PP
.I Xterm
has four menus, named
.IR mainMenu ,
.IR vtMenu ,
.IR fontMenu ,
and
.IR tekMenu .
Each menu pops up under the correct combinations of key and button presses.
Each menu is divided into sections, separated by a horizontal line.
Some menu entries correspond to modes that can be altered.
A check mark appears next to a mode that is currently active.
Selecting one of these modes toggles its state.
Other menu entries are commands;
selecting one of these performs the indicated function.
.PP
All of the menu entries correspond to X actions.
In the list below, the menu label is shown followed by the action's
name in parenthesis.
.
.\" ************************************************************************
.PP
The \fIxterm\fP \fImainMenu\fP pops up
when the ``control'' key and pointer button one are pressed in a window.
This menu contains items that apply to both the VT102 and Tektronix windows.
There are several sections:
.TP
Commands for managing X events:
.RS
.TP
Secure Keyboard (securekbd)
The
.B Secure Keyboard
mode is helpful when typing in passwords or other sensitive data in an
unsecure environment;
see \fBSECURITY\fP below (but read the limitations carefully).
.TP
Allow SendEvents (allowsends )
Specifies whether or not synthetic key and button events generated using
the X protocol SendEvent request should be interpreted or discarded.
This corresponds to the \fBallowSendEvents\fP resource.
.TP
Redraw Window (redraw)
Forces the X display to repaint;
useful in some environments.
.RE
.TP
Commands for capturing output:
.RS
.TP
Log to File (logging)
Captures text sent to the screen in a logfile,
as in the \fB-l\fP logging option.
.TP
Print Window (print)
Sends the text of the current window to the program given in the
\fBprinterCommand\fP resource.
.TP
Redirect to Printer (print-redir)
This sets the \fBprinterControlMode\fR to 0 or 2.
You can use this to turn the printer on as if an application had sent
the appropriate control sequence.
It is also useful for switching the printer
off if an application turns it on without resetting the print control mode.
.RE
.TP
Modes for setting keyboard style:
.RS
.TP
8-Bit Controls (8-bit-control)
Enabled for VT220 emulation, this controls whether \fIxterm\fP will send
8-bit control sequences rather than using 7-bit (ASCII) controls,
e.g., sending a byte in the range 128-159 rather than the escape character
followed by a second byte.
\fIXterm\fP always interprets both 8-bit and 7-bit control sequences
(see the document \fIXterm Control Sequences\fP).
This corresponds to the \fBeightBitControl\fP resource.
.TP
Backarrow Key (BS/DEL) (backarrow\ key)
Modifies the behavior of the backarrow key, making it transmit
either a backspace (8)
or delete (127) character.
This corresponds to the \fBbackarrowKey\fP resource.
.TP
Alt/NumLock Modifiers (num-lock)
Controls the treatment of Alt- and NumLock-key modifiers.
This corresponds to the \fBnumLock\fP resource.
.TP
Meta Sends Escape (meta-esc)
Controls whether \fIMeta\fP keys are converted into a two-character
sequence with the character itself preceded by ESC.
This corresponds to the \fBmetaSendsEscape\fP resource.
.TP
Delete is DEL (delete-is-del)
Controls whether the Delete key on the editing keypad should send DEL (127)
or the VT220-style Remove escape sequence.
This corresponds to the \fBdeleteIsDEL\fP resource.
.TP
Old Function-Keys (oldFunctionKeys)
.TP
HP Function-Keys (hpFunctionKeys)
.TP
SCO Function-Keys (scoFunctionKeys)
.TP
Sun Function-Keys (sunFunctionKeys)
.TP
VT220 Keyboard (sunKeyboard)
These act as a radio-button, selecting one style for the keyboard layout.
It corresponds to more than one resource setting:
.BR "sunKeyboard" ","
.BR "sunFunctionKeys" ","
.BR "scoFunctionKeys" " and"
.BR "hpFunctionKeys "."
.RE
.TP
Commands for process signalling:
.RS
.TP
Send STOP Signal (suspend)
.TP
Send CONT Signal (continue)
.TP
Send INT Signal (interrupt)
.TP
Send HUP Signal (hangup)
.TP
Send TERM Signal (terminate)
.TP
Send KILL Signal (kill)
These send the SIGTSTP, SIGCONT, SIGINT, SIGHUP, SIGTERM and SIGKILL
signals respectively, to the process group of the process running under
.I xterm
(usually the shell).
The
.B SIGCONT
function is especially useful if the user has accidentally typed CTRL-Z,
suspending the process.
.TP
Quit (quit)
Stop processing X events except to support the \fB-hold\fP option,
and then send a SIGHUP signal to the
the process group of the process running under
.I xterm
(usually the shell).
.RE
.PP
.
.\" ************************************************************************
.PP
The
.I vtMenu
sets various modes in the VT102 emulation, and is popped up when the
``control'' key and pointer button two are pressed in the VT102 window.
.TP
VT102/VT220 Modes:
.RS
.
.TP
Enable Scrollbar (scrollbar)
Enable (or disable) the scrollbar.
This corresponds to the
.B -sb
option and the
.B scrollBar
resource.
.
.TP
Enable Jump Scroll (jumpscroll)
Enable (or disable) jump scrolling.
This corresponds to the
.B -j
option and the
.B jumpScroll
resource.
.
.TP
Enable Reverse Video (reversevideo)
Enable (or disable) reverse-video.
This corresponds to the
.B -rv
option and the
.B reverseVideo
resource.
.
.TP
Enable Auto Wraparound (autowrap)
Enable (or disable) auto-wraparound.
This corresponds to the
.B -aw
option and the
.B autoWrap
resource.
.
.TP
Enable Reverse Wraparound (reversewrap)
Enable (or disable) reverse wraparound.
This corresponds to the
.B -rw
option and the
.B reverseWrap
resource.
.
.TP
Enable Auto Linefeed (autolinefeed)
Enable (or disable) auto-linefeed.
This is the VT102 NEL function,
which causes the emulator to emit a linefeed after each carriage return.
There is no corresponding command-line option or resource setting.
.
.TP
Enable Application Cursor Keys (appcursor)
Enable (or disable) application cursor keys.
This corresponds to the
.B appcursorDefault
resource.
There is no corresponding command-line option.
.
.TP
Enable Application Keypad (appkeypad)
Enable (or disable) application keypad keys.
This corresponds to the
.B appkeypadDefault
resource.
There is no corresponding command-line option.
.
.TP
Scroll to Bottom on Key Press (scrollkey)
Enable (or disable) scrolling to the bottom of the scrolling region on a keypress.
This corresponds to the
.B -sk
option and the
.B scrollKey
resource.
.
.TP
Scroll to Bottom on Tty Output (scrollttyoutput)
Enable (or disable) scrolling to the bottom of the scrolling region on output to the terminal..
This corresponds to the
.B -si
option and the
.B scrollTtyOutput
resource.
.
.TP
Allow 80/132 Column Switching (allow132)
Enable (or disable) switching between 80 and 132 columns.
This corresponds to the
.B -132
option and the
.B c132
resource.
.
.TP
Enable Curses Emulation (cursesemul)
Enable (or disable) a workaround for the so-called "curses bug".
This corresponds to the
.B -cu
option and the
.B curses
resource.
.
.TP
Enable Visual Bell (visualbell)
Enable (or disable) visible bell (i.e., flashing) instead of an audible bell.
This corresponds to the
.B -vb
option and the
.B visualBell
resource.
.
.TP
Enable Pop on Bell (poponbell)
Enable (or disable) raising of the window when Control-G is received.
This corresponds to the
.B -pop
option and the
.B popOnBell
resource.
.
.TP
Enable Margin Bell (marginbell)
Enable (or disable) a bell when the user types near the right margin.
This corresponds to the
.B -mb
option and the
.B marginBell
resource.
.
.TP
Enable Blinking Cursor (cursorblink)
Enable (or disable) the blinking-cursor feature.
This corresponds to the
.B -bc
option and the
.B cursorBlink
resource.
There is also an escape sequence
(see the document \fIXterm Control Sequences\fP).
The menu entry and the escape sequence states are XOR'd:
if both are enabled, the cursor will not blink,
if only one is enabled, the cursor will blink.
.
.TP
Enable Alternate Screen Switching (titeInhibit)
Enable (or disable) switching between the normal and alternate screens.
This corresponds to the
.B titeInhibit
resource.
There is no corresponding command-line option.
.
.TP
Enable Active Icon (activeicon)
Enable (or disable) the active-icon feature.
This corresponds to the
.B -ai
option and the
.B activeIcon
resource.
.RE
.
.TP
VT102/VT220 Commands:
.RS
.TP
Do Soft Reset (softreset)
Reset scroll regions.
This can be convenient when some program has left the scroll regions
set incorrectly (often a problem when using VMS or TOPS-20).
This corresponds to the VT220 DECSTR control sequence.
.
.TP
Do Full Reset (hardreset)
The full reset entry will clear the screen, reset tabs to every
eight columns, and reset the terminal modes (such as wrap and smooth scroll)
to their initial states just after
.I xterm
has finished processing the command line options.
This corresponds to the VT102 RIS control sequence,
with a few obvious differences.
For example, your session is not disconnected as a real VT102 would do.
.
.TP
Reset and Clear Saved Lines (clearsavedlines)
Perform a full reset,
and also clear the saved lines.
.RE
.
.TP
Commands for setting the current screen:
.RS
.
.TP
Show Tek Window (tekshow)
When enabled,
pops the Tektronix 4014 window up (makes it visible).
When disabled,
hides the Tektronix 4014 window.
.
.TP
Switch to Tek Mode (tekmode)
When enabled,
pops the Tektronix 4014 window up if it is not already visible,
and switches the input stream to that window.
When disabled,
hides the Tektronix 4014 window and
switches input back to the VTxxx window.
.
.TP
Hide VT Window (vthide)
When enabled,
hides the VTxxx window,
shows the Tektronix 4014 window if
it was not already visible
and switches the input stream to that window.
When disabled,
shows the VTxxx window,
and switches the input stream to that window.
.
.TP
Show Alternate Screen (altscreen)
When enabled,
shows the alternate screen.
When disabled,
shows the normal screen.
Note that the normal screen may have saved lines;
the alternate screen does not.
.RE
.PP
.
.PP
The \fIfontMenu\fP sets the font used in the VT102 window,
or modifies the way the font is specified or displayed.
There are three sections.
.PP
The first section allows you to select the font from a set of alternatives:
.RS
.TP
Default (fontdefault)
Set the font to the default, i.e., that given by the
.B *VT100.font
resource.
.TP
Unreadable (font1)
Set the font to that given by the
.B *VT100.font1
resource.
.TP
Tiny (font2)
Set the font to that given by the
.B *VT100.font2
resource.
.TP
Small (font3)
Set the font to that given by the
.B *VT100.font3
resource.
.TP
Medium (font4)
Set the font to that given by the
.B *VT100.font4
resource.
.TP
Large (font5)
Set the font to that given by the
.B *VT100.font5
resource.
.TP
Huge (font6)
Set the font to that given by the
.B *VT100.font6
resource.
.TP
Escape Sequence
This allows you to set the font last specified by the Set
Font escape sequence (see the document \fIXterm Control Sequences\fP).
.TP
Selection (fontsel)
This allows you to set the font specified
the current selection as a font name (if the PRIMARY selection is owned).
.RE
.PP
The second section allows you to modify the way it is displayed:
.RS
.TP
Line-Drawing Characters (font-linedrawing)
When set, tells \fIxterm\fP to draw its own line-drawing characters.
Otherwise it relies on the font containing these.
.TP
Doublesized Characters (font-doublesize)
When set, \fIxterm\fP may ask the font server to produce scaled versions
of the normal font, for VT102 double-size characters.
.RE
.PP
The third section allows you to modify the way it is specified:
.RS
.TP
TrueType Fonts (render-font)
If the
.B "renderFont
and corresponding resources were set,
this is a further control whether \fIxterm\fP will actually use the
Xft library calls to obtain a font.
.TP
UTF-8 (utf8-mode)
This controls whether \fIxterm\fP uses UTF-8 encoding of input/output.
It is useful for temporarily switching \fIxterm\fP to display
text from an application which does not follow the locale settings.
.RE
.
.PP
The
.I tekMenu
sets various modes in the Tektronix emulation, and is popped up when the
``control'' key and pointer button two are pressed in the Tektronix window.
The current font size is checked in the modes section of the menu.
.RS
.TP
Large Characters (tektextlarge)
.TP
\&#2 Size Characters (tektext2)
.TP
\&#3 Size Characters (tektext3)
.TP
Small Characters (tektextsmall)
.RE
.PP
Commands:
.RS
.TP
PAGE (tekpage)
Clear the Tektronix window.
.TP
RESET (tekreset)
.TP
COPY (tekcopy)
.RE
.PP
Windows:
.RS
.TP
Show VT Window (vtshow)
.TP
Switch to VT Mode (vtmode)
.TP
Hide Tek Window (tekhide)
.RE
.
.
.SH SECURITY
.
.PP
X environments differ in their security consciousness.
Most servers,
run under \fIxdm\fP,
are capable of using a ``magic cookie'' authorization
scheme that can provide a reasonable level of security for many people.
If your server is only using a host-based mechanism to control access to
the server (see \fIxhost(1)\fP), then if you enable access for a host and
other users are also permitted to run clients on that same host,
it is possible that someone can run an application which uses the
basic services of the X protocol to snoop on your activities,
potentially capturing a transcript of everything you type at the keyboard.
Any process which has access to your X display can manipulate it
in ways that you might not anticipate,
even redirecting your keyboard to itself
and sending events to your application's windows.
This is true even with the ``magic cookie'' authorization scheme.
While the \fBallowSendEvents\fP provides some protection against
rogue applications tampering with your programs,
guarding against a snooper is harder.
.
.PP
The possibility of an application spying on your keystrokes
is of particular concern when you want to type in a password
or other sensitive data.
The best solution to this problem is to use a better
authorization mechanism than is provided by X.
Given all of these caveats,
a simple mechanism exists for protecting keyboard input in \fIxterm\fP.
.
.PP
The \fIxterm\fP menu (see \fBMENUS\fP above) contains a \fBSecure Keyboard\fP
entry which, when enabled,
attempts to ensure that all keyboard input is directed
\fIonly\fP to \fIxterm\fP (using the GrabKeyboard protocol request).
When an application prompts you for a password
(or other sensitive data), you can enable \fBSecure Keyboard\fP using the
menu, type in the data, and then disable \fBSecure Keyboard\fP using
the menu again.
This ensures that you know which window is accepting your keystrokes.
It cannot ensure that there are no processes which have access to your
X display that might be observing the keystrokes as well.
.
.PP
Only one X client at a time can grab the keyboard,
so when you attempt to enable \fBSecure Keyboard\fP it may fail.
In this case, the bell will sound.
If the \fBSecure Keyboard\fP succeeds,
the foreground and background colors will be exchanged (as if you
selected the \fBReverse Video\fP entry in the \fBModes\fP menu);
they will be exchanged again when you exit secure mode.
If the colors
do \fInot\fP switch, then
you should be \fIvery\fP suspicious that you are being spoofed.
If the application you are running displays a prompt before asking for
the password, it is safest to enter secure mode \fIbefore\fP the
prompt gets displayed, and to make sure that the prompt gets displayed
correctly (in the new colors), to minimize the probability of
spoofing.
You can also bring up the menu again and make sure that a check
mark appears next to the entry.
.
.PP
\fBSecure Keyboard\fP mode will be disabled automatically if your \fIxterm\fP
window becomes iconified (or otherwise unmapped), or if you start up
a reparenting window manager (that places a title bar or other decoration
around the window) while in \fBSecure Keyboard\fP mode.
(This is a
feature of the X protocol not easily overcome.)  When this happens,
the foreground and background colors will be switched back and the bell
will sound in warning.
.
.
.SH "CHARACTER CLASSES"
Clicking the left mouse button twice in rapid succession will cause all
characters of the same class (e.g., letters, white space, punctuation) to be
selected.
Since different people have different preferences for what should
be selected (for example, should filenames be selected as a whole or only
the separate subnames), the default mapping can be overridden through the use
of the \fBcharClass\fP (class \fICharClass\fP) resource.
.
.PP
This resource is a
series of comma-separated
of \fIrange\fP:\fIvalue\fP pairs.
The
\fIrange\fP is either a single number or \fIlow\fP-\fIhigh\fP in the range of 0
to 65535, corresponding to the code for the character or characters to be
set.
The \fIvalue\fP is arbitrary, although the default table uses the
character number of the first character occurring in the set.
When not in
UTF-8 mode, only the first 256 bytes of this table will be used.
.
.PP
The default table starts as follows -
.sp
.in +8
.ft C			\" Courier
.nf
static int charClass[256] = {
/\(** NUL  SOH  STX  ETX  EOT  ENQ  ACK  BEL */
    32,   1,   1,   1,   1,   1,   1,   1,
/\(**  BS   HT   NL   VT   NP   CR   SO   SI */
     1,  32,   1,   1,   1,   1,   1,   1,
/\(** DLE  DC1  DC2  DC3  DC4  NAK  SYN  ETB */
     1,   1,   1,   1,   1,   1,   1,   1,
/\(** CAN   EM  SUB  ESC   FS   GS   RS   US */
     1,   1,   1,   1,   1,   1,   1,   1,
/\(**  SP    !    "    #    $    %    &    ' */
.\"   " <- for emacs autocolor to work well :-)
    32,  33,  34,  35,  36,  37,  38,  39,
/\(**   (    )    *    +    ,    -    .    / */
    40,  41,  42,  43,  44,  45,  46,  47,
/\(**   0    1    2    3    4    5    6    7 */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**   8    9    :    ;    <    =    >    ? */
    48,  48,  58,  59,  60,  61,  62,  63,
/\(**   @    A    B    C    D    E    F    G */
    64,  48,  48,  48,  48,  48,  48,  48,
/\(**   H    I    J    K    L    M    N    O */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**   P    Q    R    S    T    U    V    W */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**   X    Y    Z    [    \\    ]    ^    _ */
    48,  48,  48,  91,  92,  93,  94,  48,
/\(**   `    a    b    c    d    e    f    g */
    96,  48,  48,  48,  48,  48,  48,  48,
/\(**   h    i    j    k    l    m    n    o */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**   p    q    r    s    t    u    v    w */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**   x    y    z    {    |    }    ~  DEL */
    48,  48,  48, 123, 124, 125, 126,   1,
/\(** x80  x81  x82  x83  IND  NEL  SSA  ESA */
     1,   1,   1,   1,   1,   1,   1,   1,
/\(** HTS  HTJ  VTS  PLD  PLU   RI  SS2  SS3 */
     1,   1,   1,   1,   1,   1,   1,   1,
/\(** DCS  PU1  PU2  STS  CCH   MW  SPA  EPA */
     1,   1,   1,   1,   1,   1,   1,   1,
/\(** x98  x99  x9A  CSI   ST  OSC   PM  APC */
     1,   1,   1,   1,   1,   1,   1,   1,
/\(**   -    i   c/    L   ox   Y-    |   So */
   160, 161, 162, 163, 164, 165, 166, 167,
/\(**  ..   c0   ip   <<    _        R0    - */
   168, 169, 170, 171, 172, 173, 174, 175,
/\(**   o   +-    2    3    '    u   q|    . */
   176, 177, 178, 179, 180, 181, 182, 183,
/\(**   ,    1    2   >>  1/4  1/2  3/4    ? */
   184, 185, 186, 187, 188, 189, 190, 191,
/\(**  A`   A'   A^   A~   A:   Ao   AE   C, */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**  E`   E'   E^   E:   I`   I'   I^   I: */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**  D-   N~   O`   O'   O^   O~   O:    X */
    48,  48,  48,  48,  48,  48,  48, 215,
/\(**  O/   U`   U'   U^   U:   Y'    P    B */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**  a`   a'   a^   a~   a:   ao   ae   c, */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**  e`   e'   e^   e:    i`  i'   i^   i: */
    48,  48,  48,  48,  48,  48,  48,  48,
/\(**   d   n~   o`   o'   o^   o~   o:   -: */
    48,  48,  48,  48,  48,  48,  48, 247,
/\(**  o/   u`   u'   u^   u:   y'    P   y: */
    48,  48,  48,  48,  48,  48,  48,  48};
.fi
.ft P
.in -8
.sp
For example, the string ``33:48,37:48,45-47:48,38:48'' indicates that the
exclamation mark, percent sign, dash, period, slash, and ampersand characters
should be treated the same way as characters and numbers.
This is useful
for cutting and pasting electronic mailing addresses and filenames.
.
.
.SH ACTIONS
It is possible to rebind keys (or sequences of keys) to arbitrary strings
for input, by changing the \fBtranslations\fP resources
for the vt100 or tek4014 widgets.
Changing the \fBtranslations\fP resource
for events other than key and button events is not expected,
and will cause unpredictable behavior.
The following
actions are provided for use within the \fIvt100\fP or \fItek4014\fP
\fBtranslations\fP resources:
.TP 8
.B "allow-send-events(\fIon/off/toggle\fP)"
This action set or toggles the \fBallowSendEvents\fP resource and is also
invoked by the \fBallowsends\fP entry in \fImainMenu\fP.
.TP 8
.B "bell([\fIpercent\fP])"
This action rings the keyboard bell at the specified percentage
above or below the base volume.
.TP 8
.B "clear-saved-lines()"
This action does \fBhard-reset()\fP (see below) and also clears the history
of lines saved off the top of the screen.
It is also invoked from the \fBclearsavedlines\fP entry in \fIvtMenu\fP.
The effect is identical to a hardware reset (RIS) control sequence.
.TP 8
.B "create-menu(\fIm/v/f/t\fP)"
This action creates one of the menus used by \fIxterm\fP,
if it has not been previously created.
The parameter values are the menu names:
\fImainMenu\fP, \fIvtMenu\fP, \fIfontMenu\fP, \fItekMenu\fP, respectively.
.TP 8
.B "dabbrev-expand()"
Expands the word before cursor by searching in the preceding text on the
screen and in the scrollback buffer for words starting with that
abbreviation.
By default bound to \fBMeta\ /\fP.
Repeating \fBdabbrev-expand()\fP several times in sequence searches for an
alternative expansion by looking farther back.
Lack of more matches is signaled by a \fBbeep()\fP.
Attempts to expand an empty word
(i.e., when cursor is preceded by a space) yield successively all previous
words.
Consecutive identical expansions are ignored.
The word here is defined as a sequence of non-whitespace characters.
This feature partially emulates the behavior
of `dynamic abbreviation' expansion in Emacs (also bound there to M-/).
.TP 8
.B "deiconify()"
Changes the window state back to normal, if it was iconified.
.TP 8
.B "delete-is-del()"
This action toggles the state of the \fBdeleteIsDEL\fP resource.
.TP 8
.B "dired-button()"
Handles a button event (other than press and release)
by echoing the event's position
(i.e., character line and column) in the following format:
.sp
.in +8
^X ESC G <line+' '> <col+' '>
.in -8
.TP 8
.B "iconify()"
Iconifies the window.
.TP 8
.B "hard-reset()"
This action resets the scrolling region, tabs, window size, and cursor keys
and clears the screen.
It is also invoked from the \fBhardreset\fP
entry in \fIvtMenu\fP.
.TP 8
.B "ignore()"
This action ignores the event but checks for special pointer position
escape sequences.
.TP 8
.B "insert()"
This action inserts the character or string associated with
the key that was pressed.
.TP 8
.B "insert-eight-bit()"
This action inserts an eight-bit (Meta) version of the character or string
associated with the key that was pressed.
The exact action depends on the value of
the \fBmetaSendsEscape\fP and
the \fBeightBitInput\fP resources.
.TP 8
.B "insert-selection(\fIsourcename\fP [, ...])"
This action inserts the string found in the selection or cutbuffer indicated
by \fIsourcename\fP.
Sources are checked in the order given (case is
significant) until one is found.
Commonly-used selections include:
\fIPRIMARY\fP, \fISECONDARY\fP, and \fICLIPBOARD\fP.
Cut buffers are
typically named \fICUT_BUFFER0\fP through \fICUT_BUFFER7\fP.
.TP 8
.B "insert-seven-bit()"
This action is a synonym for \fBinsert()\fP
.TP 8
.B "interpret(\fIcontrol-sequence\fP)"
Interpret the given control sequence locally, i.e., without passing it to
the host.
This works by inserting the control sequence at the front
of the input buffer.
Use "\\" to escape octal digits in the string.
Xt does not allow you to put a null character (i.e., "\\000") in the string.
.TP 8
.B "keymap(\fIname\fP)"
This action dynamically defines a new translation table whose resource
name is \fIname\fP with the suffix \fIKeymap\fP (case is significant).
The name \fINone\fP restores the original translation table.
.TP 8
.B "larger-vt-font()"
Set the font to the next larger one, based on the font dimensions.
See also \fBset-vt-font()\fP.
.TP 8
.B "load-vt-fonts(\fIname\fP[,\fIclass\fP])"
Load fontnames from the given subresource name and class.
That is, load the "*VT100.\fIname\fP.font", resource as "*VT100.font" etc.
If no name is given, the original set of fontnames is restored.
.IP
Unlike \fBset-vt-font()\fR, this does not affect the escape- and select-fonts,
since those are not based on resource values.
It does affect the fonts loosely organized under the ``Default'' menu
entry: \fBfont\fP, \fBboldFont\fP, \fBwideFont\fP and \fBwideBoldFont\fP.
.TP 8
.B "maximize()"
Resizes the window to fill the screen.
.TP 8
.B "meta-sends-escape()"
This action toggles the state of the \fBmetaSendsEscape\fP resource.
.TP 8
.B "popup-menu(\fImenuname\fP)"
This action displays the specified popup menu.
Valid names (case is
significant) include:  \fImainMenu\fP, \fIvtMenu\fP, \fIfontMenu\fP,
and \fItekMenu\fP.
.TP 8
.B "print()"
This action prints the window and is also invoked by the
\fIprint\fP entry in \fImainMenu\fP.
.TP 8
.B "print-redir()"
This action toggles the \fBprinterControlMode\fR between 0 and 2.
The corresponding popup menu entry is useful for switching the printer
off if you happen to change your mind after deciding to print random
binary files on the terminal.
.TP 8
.B "quit()"
This action sends a SIGHUP to the subprogram and exits.
It is also invoked
by the \fBquit\fP entry in \fImainMenu\fP.
.TP 8
.B "redraw()"
This action redraws the window and is also invoked by the
\fIredraw\fP entry in \fImainMenu\fP.
.TP 8
.B "restore()"
Restores the window to the size before it was last maximized.
.TP 8
.B "scroll-back(\fIcount\fP [,\fIunits\fP [,\fImouse\fP] ])"
This action scrolls the text window backward so that text that had previously
scrolled off the top of the screen is now visible.
.IP
The \fIcount\fP argument
indicates the number of \fIunits\fP (which may be \fIpage\fP, \fIhalfpage\fP,
\fIpixel\fP, or \fIline\fP) by which to scroll.
.IP
An adjustment can be specified for these values by appending a "+" or "-"
sign followed by a number,
e.g., \fIpage-2\fP to specify 2 lines less than a page.
.IP
If the third parameter \fImouse\fP is given, the action is ignored when
mouse reporting is enabled.
.TP 8
.B "scroll-forw(\fIcount\fP [,\fIunits\fP [,\fImouse\fP] ])"
This action is similar to \fBscroll-back\fP except that it scrolls
in the other direction.
.TP 8
.B "secure()"
This action toggles the \fISecure Keyboard\fP mode described in the
section named \fBSECURITY\fP, and is invoked from the \fBsecurekbd\fP
entry in \fImainMenu\fP.
.TP 8
.B "select-cursor-end(\fIdestname\fP [, ...])"
This action is similar to \fBselect-end\fP except that it should be used
with \fBselect-cursor-start\fP.
.TP 8
.B "select-cursor-start()"
This action is similar to \fBselect-start\fP except that it begins the
selection at the current text cursor position.
.TP 8
.B "select-end(\fIdestname\fP [, ...])"
This action puts the currently selected text into all of the selections or
cutbuffers specified by \fIdestname\fP.
.TP 8
.B "select-extend()"
This action tracks the pointer and extends the selection.
It should only be bound to Motion events.
.TP 8
.B "select-set()"
This action stores text that corresponds to the current selection,
without affecting the selection mode.
.TP 8
.B "select-start()"
This action begins text selection at the current pointer location.
See
the section on \fBPOINTER USAGE\fP for information on making selections.
.TP 8
.B "send-signal(\fIsigname\fP)"
This action sends the signal named by \fIsigname\fP
to the \fIxterm\fP subprocess (the shell or program specified with
the \fI-e\fP command line option) and is also invoked by the
.BR suspend ,
.BR continue ,
.BR interrupt ,
.BR hangup ,
.BR terminate ,
and
.BR kill
entries in \fImainMenu\fP.
Allowable signal names are (case is
not significant):
\fItstp\fP (if supported by the operating system), \fIsuspend\fP (same
as \fItstp\fP), \fIcont\fP
(if supported by the operating system), \fIint\fP, \fIhup\fP, \fIterm\fP,
\fIquit\fP,
\fIalrm\fP, \fIalarm\fP (same as \fIalrm\fP) and \fIkill\fP.
.TP 8
.B "set-allow132(\fIon/off/toggle\fP)"
This action toggles the \fBc132\fP resource and is also invoked from the
\fBallow132\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-altscreen(\fIon/off/toggle\fP)"
This action toggles between the alternate and current screens.
.TP 8
.B "set-appcursor(\fIon/off/toggle\fP)"
This action toggles the handling Application Cursor Key mode
and is also invoked by the \fBappcursor\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-appkeypad(\fIon/off/toggle\fP)"
This action toggles the handling of Application Keypad mode and is also
invoked by the \fBappkeypad\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-autolinefeed(\fIon/off/toggle\fP)"
This action toggles automatic insertion of linefeeds and is also invoked by
the \fBautolinefeed\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-autowrap(\fIon/off/toggle\fP)"
This action toggles automatic wrapping of long lines and is also invoked by
the \fBautowrap\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-backarrow(\fIon/off/toggle\fP)"
This action toggles the \fBbackarrowKey\fP resource and is also invoked from the
\fBbackarrow key\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-cursorblink(\fIon/off/toggle\fP)"
This action toggles the \fBcursorBlink\fP resource and is also invoked from the
\fBcursorblink\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-cursesemul(\fIon/off/toggle\fP)"
This action toggles the \fBcurses\fP resource and is also invoked from the
\fBcursesemul\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-font-doublesize(\fIon/off/toggle\fP)"
This action toggles the \fBfontDoublesize\fP resource and is also invoked by
the \fBfont-doublesize\fP entry in \fIfontMenu\fP.
.TP 8
.B "set-hp-function-keys(\fIon/off/toggle\fP)"
This action toggles the \fBhpFunctionKeys\fP resource and is also invoked by
the \fBhpFunctionKeys\fP entry in \fImainMenu\fP.
.TP 8
.B "set-jumpscroll(\fIon/off/toggle\fP)"
This action toggles the \fBjumpscroll\fP resource and is also invoked by the
\fBjumpscroll\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-font-linedrawing(\fIon/off/toggle\fP)"
This action toggles the \fIxterm\fR's state regarding whether the current font
has line-drawing characters and whether it should draw them directly.
It is also invoked by the \fBfont-linedrawing\fP entry in \fIfontMenu\fP.
.TP 8
.B "set-logging()"
This action toggles the state of the logging option.
.TP 8
.B "set-old-function-keys(\fIon/off/toggle\fP)"
This action toggles the state of legacy function keys and is also invoked by
the \fBoldFunctionKeys\fP entry in \fImainMenu\fP.
.TP 8
.B "set-marginbell(\fIon/off/toggle\fP)"
This action toggles the \fBmarginBell\fP resource and is also invoked from
the \fBmarginbell\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-num-lock()"
This action toggles the state of the \fBnumLock\fP resource.
.TP 8
.B "set-pop-on-bell(\fIon/off/toggle\fP)"
This action toggles the \fBpopOnBell\fP resource and is also invoked
by the \fBpoponbell\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-render-font(\fIon/off/toggle\fP)"
This action toggles the \fBrenderFont\fP resource and is also invoked by
the \fBrender-font\fP entry in \fIfontMenu\fP.
.TP 8
.B "set-reverse-video(\fIon/off/toggle\fP)"
This action toggles the \fBreverseVideo\fP resource and is also invoked by
the \fBreversevideo\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-reversewrap(\fIon/off/toggle\fP)"
This action toggles the \fBreverseWrap\fP resource and is also invoked by
the \fBreversewrap\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-scroll-on-key(\fIon/off/toggle\fP)"
This action toggles the \fBscrollKey\fP resource and is also invoked from
the \fBscrollkey\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-scroll-on-tty-output(\fIon/off/toggle\fP)"
This action toggles the \fBscrollTtyOutput\fP resource and is also invoked
from the \fBscrollttyoutput\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-scrollbar(\fIon/off/toggle\fP)"
This action toggles the \fBscrollbar\fP resource and is also invoked by
the \fBscrollbar\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-sco-function-keys(\fIon/off/toggle\fP)"
This action toggles the \fBscoFunctionKeys\fP resource and is also invoked by
the \fBscoFunctionKeys\fP entry in \fImainMenu\fP.
.TP 8
.B "set-sun-function-keys(\fIon/off/toggle\fP)"
This action toggles the \fBsunFunctionKeys\fP resource and is also invoked by
the \fBsunFunctionKeys\fP entry in \fImainMenu\fP.
.TP 8
.B "set-sun-keyboard(\fIon/off/toggle\fP)"
This action toggles the \fBsunKeyboard\fP resource and is also invoked by
the \fBsunKeyboard\fP entry in \fImainMenu\fP.
.TP 8
.B "set-tek-text(\fIlarge/2/3/small\fP)"
This action sets font used in the Tektronix window to the value of the
resources \fBtektextlarge\fP, \fBtektext2\fP, \fBtektext3\fP, and
\fBtektextsmall\fP according to the argument.
It is also by the entries
of the same names as the resources in \fItekMenu\fP.
.TP 8
.B "set-terminal-type(\fItype\fP)"
This action directs output to either the \fIvt\fP or \fItek\fP windows,
according to the \fItype\fP string.
It is also invoked by the
\fBtekmode\fP entry in \fIvtMenu\fP and the \fBvtmode\fP entry in
\fItekMenu\fP.
.TP 8
.B "set-titeInhibit(\fIon/off/toggle\fP)"
This action toggles the \fBtiteInhibit\fP resource,
which controls switching between the alternate and current screens.
.TP 8
.\" should toggle "toolBar" resource (see note).
.B "set-toolbar(\fIon/off/toggle\fP)"
This action toggles the toolbar feature and is also invoked by
the \fBtoolbar\fP entry in \fImainMenu\fP.
.TP 8
.B "set-utf8-mode(\fIon/off/toggle\fP)"
This action toggles the \fButf8\fP resource and is also invoked by
the \fButf8-mode\fP entry in \fIfontMenu\fP.
.TP 8
.B "set-visibility(\fIvt/tek\fP,\fIon/off/toggle\fP)"
This action controls whether or not the \fIvt\fP or \fItek\fP windows are
visible.
It is also invoked from the \fBtekshow\fP and \fBvthide\fP entries
in \fIvtMenu\fP and the \fBvtshow\fP and \fBtekhide\fP entries in
\fItekMenu\fP.
.TP 8
.B "set-visual-bell(\fIon/off/toggle\fP)"
This action toggles the \fBvisualBell\fP resource and is also invoked
by the \fBvisualbell\fP entry in \fIvtMenu\fP.
.TP 8
.B "set-vt-font(\fId/1/2/3/4/5/6/e/s\fP [,\fInormalfont\fP [, \fIboldfont\fP]])"
This action sets the font or fonts currently being used in the VT102 window.
The first argument is a single character that specifies the font to be
used:
.RS 8
.HP
\fId\fP or \fID\fP indicate the default font (the font initially
used when
\fIxterm\fP was started),
.HP
\fI1\fP through \fI6\fP indicate the fonts
specified by the \fIfont1\fP through \fIfont6\fP resources,
.HP
\fIe\fP or \fIE\fP
indicate the normal and bold fonts that have been set through escape codes
(or specified as the second and third action arguments, respectively), and
.HP
\fIs\fP or \fIS\fP indicate the font selection (as made by programs such as
\fIxfontsel(1)\fP) indicated by the second action argument.
.RE
.IP
If \fIxterm\fR is configured to support wide characters, an
additional two optional parameters are recognized for the \fIe\fP argument:
wide font and wide bold font.
.TP 8
.B "smaller-vt-font()"
Set the font to the next smaller one, based on the font dimensions.
See also \fBset-vt-font()\fP.
.TP 8
.B "soft-reset()"
This action resets the scrolling region and is also invoked from the
\fBsoftreset\fP entry in \fIvtMenu\fP.
The effect is identical to a soft reset (DECSTR) control sequence.
.TP 8
.B "start-extend()"
This action is similar to \fBselect-start\fP except that the
selection is extended to the current pointer location.
.TP 8
.B "start-cursor-extend()"
This action is similar to \fBselect-extend\fP except that the
selection is extended to the current text cursor position.
.TP 8
.B "string(\fIstring\fP)"
This action inserts the specified text string as if it had been typed.
Quotation is necessary if the string contains whitespace or
non-alphanumeric characters.
If the string argument begins with the
characters ``0x'', it is interpreted
as a hex character constant.
.TP 8
.B "tek-copy()"
This action copies the escape codes used to generate the current window
contents to a file in the current directory beginning with the name COPY.
It is also invoked from the \fItekcopy\fP entry in \fItekMenu\fP.
.TP 8
.B "tek-page()"
This action clears the Tektronix window and is also invoked by the
\fBtekpage\fP entry in \fItekMenu\fP.
.TP 8
.B "tek-reset()"
This action resets the Tektronix window and is also invoked by the
\fItekreset\fP entry in \fItekMenu\fP.
.TP 8
.B "vi-button()"
Handles a button event (other than press and release)
by echoing a control sequence computed from the event's line number
in the screen relative to the current line:
.sp
.in +8
ESC ^P
.in -8
or
.in +8
ESC ^N
.in -8
.sp
according to whether the event is before, or after the current line,
respectively.
The ^N (or ^P) is repeated once for each line that the event differs
from the current line.
The control sequence is omitted altogether if the button event is on the
current line.
.TP 8
.B "visual-bell()"
This action flashes the window quickly.
.
.PP
The Tektronix window also has the following action:
.TP 8
.B "gin-press(\fIl/L/m/M/r/R\fP)"
This action sends the indicated graphics input code.
.
.PP
The default bindings in the VT102 window are:
.sp
.in +4
.ta 2.5i
.ft C			\" Courier
.nf
          Shift <KeyPress> Prior:scroll-back(1,halfpage) \\n\\
           Shift <KeyPress> Next:scroll-forw(1,halfpage) \\n\\
         Shift <KeyPress> Select:select-cursor-start() \\
                                 select-cursor-end(PRIMARY, CUT_BUFFER0) \\n\\
         Shift <KeyPress> Insert:insert-selection(PRIMARY, CUT_BUFFER0) \\n\\
    Shift~Ctrl <KeyPress> KP_Add:larger-vt-font() \\n\\
    Shift Ctrl <KeyPress> KP_Add:smaller-vt-font() \\n\\
    Shift <KeyPress> KP_Subtract:smaller-vt-font() \\n\\
                ~Meta <KeyPress>:insert-seven-bit() \\n\\
                 Meta <KeyPress>:insert-eight-bit() \\n\\
                !Ctrl <Btn1Down>:popup-menu(mainMenu) \\n\\
           !Lock Ctrl <Btn1Down>:popup-menu(mainMenu) \\n\\
 !Lock Ctrl @Num_Lock <Btn1Down>:popup-menu(mainMenu) \\n\\
     ! @Num_Lock Ctrl <Btn1Down>:popup-menu(mainMenu) \\n\\
                ~Meta <Btn1Down>:select-start() \\n\\
              ~Meta <Btn1Motion>:select-extend() \\n\\
                !Ctrl <Btn2Down>:popup-menu(vtMenu) \\n\\
           !Lock Ctrl <Btn2Down>:popup-menu(vtMenu) \\n\\
 !Lock Ctrl @Num_Lock <Btn2Down>:popup-menu(vtMenu) \\n\\
     ! @Num_Lock Ctrl <Btn2Down>:popup-menu(vtMenu) \\n\\
          ~Ctrl ~Meta <Btn2Down>:ignore() \\n\\
                 Meta <Btn2Down>:clear-saved-lines() \\n\\
            ~Ctrl ~Meta <Btn2Up>:insert-selection(PRIMARY, CUT_BUFFER0) \\n\\
                !Ctrl <Btn3Down>:popup-menu(fontMenu) \\n\\
           !Lock Ctrl <Btn3Down>:popup-menu(fontMenu) \\n\\
 !Lock Ctrl @Num_Lock <Btn3Down>:popup-menu(fontMenu) \\n\\
     ! @Num_Lock Ctrl <Btn3Down>:popup-menu(fontMenu) \\n\\
          ~Ctrl ~Meta <Btn3Down>:start-extend() \\n\\
              ~Meta <Btn3Motion>:select-extend() \\n\\
                 Ctrl <Btn4Down>:scroll-back(1,halfpage,m) \\n\\
            Lock Ctrl <Btn4Down>:scroll-back(1,halfpage,m) \\n\\
  Lock @Num_Lock Ctrl <Btn4Down>:scroll-back(1,halfpage,m) \\n\\
       @Num_Lock Ctrl <Btn4Down>:scroll-back(1,halfpage,m) \\n\\
                      <Btn4Down>:scroll-back(5,line,m)     \\n\\
                 Ctrl <Btn5Down>:scroll-forw(1,halfpage,m) \\n\\
            Lock Ctrl <Btn5Down>:scroll-forw(1,halfpage,m) \\n\\
  Lock @Num_Lock Ctrl <Btn5Down>:scroll-forw(1,halfpage,m) \\n\\
       @Num_Lock Ctrl <Btn5Down>:scroll-forw(1,halfpage,m) \\n\\
                      <Btn5Down>:scroll-forw(5,line,m)     \\n\\
                         <BtnUp>:select-end(PRIMARY, CUT_BUFFER0) \\n\\
                       <BtnDown>:ignore()
.fi
.ft P
.sp
.in -4
.PP
The default bindings in the Tektronix window are:
.sp
.in +4
.ta 2.5i
.nf
.ft C			\" Courier
                ~Meta<KeyPress>: 	insert-seven-bit() \\n\\
                 Meta<KeyPress>: 	insert-eight-bit() \\n\\
               !Ctrl <Btn1Down>: 	popup-menu(mainMenu) \\n\\
          !Lock Ctrl <Btn1Down>: 	popup-menu(mainMenu) \\n\\
!Lock Ctrl @Num_Lock <Btn1Down>:	popup-menu(mainMenu) \\n\\
     !Ctrl @Num_Lock <Btn1Down>:	popup-menu(mainMenu) \\n\\
               !Ctrl <Btn2Down>: 	popup-menu(tekMenu) \\n\\
          !Lock Ctrl <Btn2Down>: 	popup-menu(tekMenu) \\n\\
!Lock Ctrl @Num_Lock <Btn2Down>:	popup-menu(tekMenu) \\n\\
     !Ctrl @Num_Lock <Btn2Down>:	popup-menu(tekMenu) \\n\\
          Shift ~Meta<Btn1Down>:	gin-press(L) \\n\\
                ~Meta<Btn1Down>:	gin-press(l) \\n\\
          Shift ~Meta<Btn2Down>:	gin-press(M) \\n\\
                ~Meta<Btn2Down>:	gin-press(m) \\n\\
          Shift ~Meta<Btn3Down>:	gin-press(R) \\n\\
                ~Meta<Btn3Down>:	gin-press(r)
.fi
.ft P
.sp
.in -4
.PP
Here is an example which uses shifted select/paste to copy to the clipboard,
and unshifted select/paste for the primary selection.
In each case, a (different) cut buffer is
also a target or source of the select/paste operation.
It is important to remember however,
that cut buffers store data in ISO-8859-1 encoding,
while selections can store data in a variety of formats and encodings.
While \fIxterm\fP owns the selection, it highlights it.
When it loses the selection, it removes the corresponding highlight.
But you can still paste from the corresponding cut buffer.
.sp
.in +4
.nf
.ta .5i 1.5i
.nf
.ft C			\" Courier
*VT100*translations:    #override \\n\\
    ~Shift~Ctrl<Btn2Up>: insert-selection(PRIMARY, CUT_BUFFER0) \\n\\
    Shift~Ctrl<Btn2Up>:  insert-selection(CLIPBOARD, CUT_BUFFER1) \\n\\
    ~Shift<BtnUp>:       select-end(PRIMARY, CUT_BUFFER0) \\n\\
    Shift<BtnUp>:        select-end(CLIPBOARD, CUT_BUFFER1)
.fi
.ft P
.sp
.in -4
.PP
Below is a sample how of the \fBkeymap()\fP action is used to add special
keys for entering commonly-typed works:
.sp
.in +4
.nf
.ta .5i 1.5i
.nf
.ft C			\" Courier
*VT100.Translations: #override <Key>F13: keymap(dbx)
*VT100.dbxKeymap.translations: \\
	<Key>F14:	keymap(None) \\n\\
	<Key>F17:	string("next") string(0x0d) \\n\\
	<Key>F18:	string("step") string(0x0d) \\n\\
	<Key>F19:	string("continue") string(0x0d) \\n\\
	<Key>F20:	string("print ") insert-selection(PRIMARY, CUT_BUFFER0)
.fi
.ft P
.sp
.in -4
.SH "CONTROL SEQUENCES AND KEYBOARD"
The \fIXterm Control Sequences\fP document lists the control sequences which
an application can send \fIxterm\fP to make it perform various operations.
Most of these operations are standardized, from either the DEC or Tektronix
terminals, or from more widely used standards such as ISO 6429.
.
.
.SH ENVIRONMENT
.I Xterm
sets the environment variables ``TERM'' for the window you have created.
It also uses and sets the environment
variable ``DISPLAY'' to specify which bit map display terminal to use.
The environment variable ``WINDOWID'' is set to the X window id number
of the
.I xterm
window.
.
.PP
Depending on your system configuration, \fIxterm\fP may also set the
following:
.TP 5
COLUMNS
the width of the \fIxterm\fP in characters (cf: "stty columns").
.TP 5
HOME
when \fIxterm\fP is configured to update utmp.
.TP 5
LINES
the height of the \fIxterm\fP in characters (cf: "stty rows").
.TP 5
LOGNAME
when \fIxterm\fP is configured to update utmp.
.TP 5
SHELL
when \fIxterm\fP is configured to update utmp.
.TP 5
TERMCAP
the contents of the termcap entry corresponding to $TERM,
with lines and columns values substituted
for the actual size window you have created.
.TP 5
TERMINFO
may be defined to a nonstandard location in the configure script.
.\"
.
.
.SH FILES
The actual pathnames given may differ on your system.
.TP 5
\fI/etc/utmp\fP
the system logfile, which records user logins.
.TP 5
\fI/etc/wtmp\fP
the system logfile, which records user logins and logouts.
.TP 5
.I __apploaddir__/XTerm
the \fIxterm\fP default application resources.
.TP 5
.I __apploaddir__/XTerm-color
the \fIxterm\fP color application resources.
If your display supports color, use this
.in +10
*customization: -color
.in -10
in your .Xdefaults file to
automatically turn on color in \fIxterm\fP and similar applications.
.
.
.SH ERROR MESSAGES
Most of the fatal error messages from \fIxterm\fP use the following format:
.RS
xterm: Error \fIXXX\fP, errno \fIYYY\fP: \fIZZZ\fP
.RE
The \fIXXX\fP codes (which are used by \fIxterm\fP as its exit-code)
are listed below, with a brief explanation.
.TP 5
1
is used for miscellaneous errors, usually accompanied by a specific message,
.TP
11
ERROR_FIONBIO
.br
main: ioctl() failed on FIONBIO
.TP
12
ERROR_F_GETFL
.br
main: ioctl() failed on F_GETFL
.TP
13
ERROR_F_SETFL
.br
main: ioctl() failed on F_SETFL
.TP
14
ERROR_OPDEVTTY
.br
spawn: open() failed on /dev/tty
.TP
15
ERROR_TIOCGETP
.br
spawn: ioctl() failed on TIOCGETP
.TP
17
ERROR_PTSNAME
.br
spawn: ptsname() failed
.TP
18
ERROR_OPPTSNAME
.br
spawn: open() failed on ptsname
.TP
19
ERROR_PTEM
.br
spawn: ioctl() failed on I_PUSH/"ptem"
.TP
20
ERROR_CONSEM
.br
spawn: ioctl() failed on I_PUSH/"consem"
.TP
21
ERROR_LDTERM
.br
spawn: ioctl() failed on I_PUSH/"ldterm"
.TP
22
ERROR_TTCOMPAT
.br
spawn: ioctl() failed on I_PUSH/"ttcompat"
.TP
23
ERROR_TIOCSETP
.br
spawn: ioctl() failed on TIOCSETP
.TP
24
ERROR_TIOCSETC
.br
spawn: ioctl() failed on TIOCSETC
.TP
25
ERROR_TIOCSETD
.br
spawn: ioctl() failed on TIOCSETD
.TP
26
ERROR_TIOCSLTC
.br
spawn: ioctl() failed on TIOCSLTC
.TP
27
ERROR_TIOCLSET
.br
spawn: ioctl() failed on TIOCLSET
.TP
28
ERROR_INIGROUPS
.br
spawn: initgroups() failed
.TP
29
ERROR_FORK
.br
spawn: fork() failed
.TP
30
ERROR_EXEC
.br
spawn: exec() failed
.TP
32
ERROR_PTYS
.br
get_pty: not enough ptys
.TP
34
ERROR_PTY_EXEC
.br
waiting for initial map
.TP
35
ERROR_SETUID
.br
spawn: setuid() failed
.TP
36
ERROR_INIT
.br
spawn: can't initialize window
.TP
46
ERROR_TIOCKSET
.br
spawn: ioctl() failed on TIOCKSET
.TP
47
ERROR_TIOCKSETC
.br
spawn: ioctl() failed on TIOCKSETC
.TP
48
ERROR_SPREALLOC
.br
spawn: realloc of ttydev failed
.TP
49
ERROR_LUMALLOC
.br
luit: command-line malloc failed
.TP
50
ERROR_SELECT
.br
in_put: select() failed
.TP
54
ERROR_VINIT
.br
VTInit: can't initialize window
.TP
57
ERROR_KMMALLOC1
.br
HandleKeymapChange: malloc failed
.TP
60
ERROR_TSELECT
.br
Tinput: select() failed
.TP
64
ERROR_TINIT
.br
TekInit: can't initialize window
.TP
71
ERROR_BMALLOC2
.br
SaltTextAway: malloc() failed
.TP
80
ERROR_LOGEXEC
.br
StartLog: exec() failed
.TP
83
ERROR_XERROR
.br
xerror: XError event
.TP
84
ERROR_XIOERROR
.br
xioerror: X I/O error
.TP
90
ERROR_SCALLOC
.br
Alloc: calloc() failed on base
.TP
91
ERROR_SCALLOC2
.br
Alloc: calloc() failed on rows
.TP
92
ERROR_SREALLOC
.br
ScreenResize: realloc() failed on alt base
.TP
96
ERROR_RESIZE
.br
ScreenResize: malloc() or realloc() failed
.TP
102
ERROR_SAVE_PTR
.br
ScrnPointers: malloc/realloc() failed
.TP
110
ERROR_SBRALLOC
.br
ScrollBarOn: realloc() failed on base
.TP
111
ERROR_SBRALLOC2
.br
ScrollBarOn: realloc() failed on rows
.TP
121
ERROR_MMALLOC
.br
my_memmove: malloc/realloc failed
.
.
.SH BUGS
.
.PP
Large pastes do not work on some systems.
This is not a bug in
\fIxterm\fP; it is a bug in the pseudo terminal driver of those
systems.
\fIxterm\fP feeds large pastes to the pty only as fast as the pty
will accept data, but some pty drivers do not return enough information
to know if the write has succeeded.
.
.PP
Many of the options are not resettable after
.I xterm
starts.
.
.PP
This program still needs to be rewritten.
It should be split into very
modular sections, with the various emulators being completely separate
widgets that do not know about each other.
Ideally, you'd like to be able to
pick and choose emulator widgets and stick them into a single control widget.
.
.PP
There needs to be a dialog box to allow entry of the Tek COPY file name.
.
.
.SH "SEE ALSO"
resize(1), luit(1), X(__miscmansuffix__), pty(4), tty(4)
.br
\fIXterm Control Sequences\fP
(this is the file ctlseqs.ms).
.sp
http://invisible-island.net/xterm/xterm.html
.
.
.SH AUTHORS
Far too many people, including:
.sp
Loretta Guarino Reid (DEC-UEG-WSL),
Joel McCormack (DEC-UEG-WSL), Terry Weissman (DEC-UEG-WSL),
Edward Moy (Berkeley), Ralph R. Swick (MIT-Athena),
Mark Vandevoorde (MIT-Athena), Bob McNamara (DEC-MAD),
Jim Gettys (MIT-Athena), Bob Scheifler (MIT X Consortium), Doug Mink (SAO),
Steve Pitschke (Stellar), Ron Newman (MIT-Athena), Jim Fulton (MIT X
Consortium), Dave Serisky (HP), Jonathan Kamens (MIT-Athena),
Jason Bacon,
Stephen P. Wall,
David Wexelblat, and
Thomas Dickey (XFree86 Project).
